
bool TestIntValue(int nValue, int nCompareValue, string sOperation)
{
	switch(sOperation)
	{
	case ">=":
			if(nValue >= nCompareValue) return true;
			return false;
	break;
	case "<=":
			if(nValue <= nCompareValue) return true;
			return false;
	break;
	case "=":
			if(nValue == nCompareValue) return true;
			return false;
	break;
	case ">":
			if(nValue > nCompareValue) return true;
			return false;
	break;
	case "<":
			if(nValue < nCompareValue) return true;
			return false;	
	break;
	}
	trace("ERROR: invalid operation(" + sOperation + ")");
	return false;
}

bool ProcessCondition(aref condition)
{
	bool bTmp;
	int i;
	ref tmpRef;
	ref refCharacter;
	string sConditionName;
	string sTmpString;
	string locGroup;
	float fx,fy,fz;
	string sLocation;
	int iLocation;

	sConditionName = GetAttributeValue(condition);
	if(CheckAttribute(condition,"characterIdx"))
	{
		condition.character = sti(condition.characterIdx);
		DeleteAttribute(condition,"characterIdx");
	}
	if(CheckAttribute(condition,"character"))
	{
		refCharacter= GetCharacter(sti(condition.character));
		if(!CheckAttribute(refCharacter, "id"))
		{
			refCharacter = &characters[GetCharacterIndex(condition.character)];
		}
	}
	else
	{
		refCharacter = pchar;
	}

	switch(sConditionName)
	{
	case "Goods":
		return TestIntValue(GetCargoGoods(refCharacter,sti(condition.goods)),sti(condition.quantity),condition.operation);
	break;
	case "party_goods":
		return TestIntValue(GetSquadronGoods(refCharacter,sti(condition.goods)),sti(condition.quantity),condition.operation);
	break;
	case "item":
		return CheckCharacterItem(refCharacter,condition.item);
	break;
	case "passenger":
		if(CheckAttribute(condition,"npc"))
		{
			condition.npcIdx = "" + GetCharacterIndex(condition.npc);
			DeleteAttribute(condition,"npc");
		}
		i = FindFellowtravellers(refCharacter,GetCharacter(sti(condition.npcIdx)));
		if(i==FELLOWTRAVEL_PASSENGER) return true;
		if(i==FELLOWTRAVEL_OFFICER) return true;
		if(i==FELLOWTRAVEL_CAPTIVE) return true;
		return false;
	break;
	case "prisoner":
		if(CheckAttribute(condition,"npc"))
		{
			condition.npcIdx = "" + GetCharacterIndex(condition.npc);
			DeleteAttribute(condition,"npc");
		}
		i = FindFellowtravellers(refCharacter,GetCharacter(sti(condition.npcIdx)));
		return i==FELLOWTRAVEL_CAPTIVE;
	break;
	case "officer":
		if(CheckAttribute(condition,"npc"))
		{
			condition.npcIdx = "" + GetCharacterIndex(condition.npc);
			DeleteAttribute(condition,"npc");
		}
		i = FindFellowtravellers(refCharacter,GetCharacter(sti(condition.npcIdx)));
		return i==FELLOWTRAVEL_OFFICER;
	break;
	case "companion":
		if(CheckAttribute(condition,"npc"))
		{
			condition.npcIdx = "" + GetCharacterIndex(condition.npc);
			DeleteAttribute(condition,"npc");
		}
		i = FindFellowtravellers(refCharacter,GetCharacter(sti(condition.npcIdx)));
		return i==FELLOWTRAVEL_COMPANION;
	break;
	case "ship_class":
		i = GetCharacterShipClass(refCharacter);
		if(i==-1) return false;
		return TestIntValue(i,sti(condition.class),condition.operation);
	break;
	case "ship":
		return GetCharacterShipType(refCharacter) == sti(condition.type);
	break;
	case "cannons":
		return GetCaracterShipCannonsType(refCharacter) == sti(condition.type);
	break;
	case "hold_space":
		return TestIntValue(GetCargoFreeSpace(refCharacter),sti(condition.quantity),condition.operation);
	break;
	case "party_hold_space":
		i = GetSquadronFreeSpace(refCharacter,sti(condition.goods));
		return TestIntValue(i,sti(condition.quantity),condition.operation);
	break;
	case "Crew_Space":
		return TestIntValue(GetFreeCrewQuantity(refCharacter),sti(condition.quantity),condition.operation);
	break;
	case "Party_Crew_Space":
		return TestIntValue(GetFreePartyCrewQuantity(refCharacter),sti(condition.quantity),condition.operation);
	break;
	case "Skill":
		i = GetCharacterSkill(refCharacter,condition.skill);
		return TestIntValue(i,sti(condition.value),condition.operation);
	break;
	case "Party_Skill":
		i = GetSummonSkillFromName(refCharacter,condition.skill);
		return TestIntValue(i,sti(condition.value),condition.operation);
	break;
	case "Rank":
		return TestIntValue(sti(refCharacter.rank),sti(condition.value),condition.operation);
	break;
	case "Reputation":
		return TestIntValue(sti(refCharacter.reputation),sti(condition.value),condition.operation);
	break;
	case "relation":
		i = GetNationRelation2Character(GetNationTypeByName(condition.nation),sti(refCharacter.index));
		bTmp = false;
		switch(condition.relation)
		{
		case "Friendly":	bTmp = i==RELATION_FRIEND; break;
		case "Hostile":		bTmp = i==RELATION_ENEMY; break;
		case "Neutral":		bTmp = i==RELATION_NEUTRAL; break;
		}
		return bTmp;
	break;
	
	case "location":
		if(refCharacter.location==condition.location) return !CharacterIsDead(refCharacter);
		return false;
	break;

	case "nation_location":
		int iNation = sti(condition.nation);
		sLocation = refCharacter.location;
		iLocation = FindLocation(sLocation);
		if(iLocation != -1)
		{
			if(CheckAttribute(&Locations[iLocation], "fastreload"))
			{
				sLocation = Locations[iLocation].fastreload;
				int iCurrentNation = sti(Colonies[FindColony(sLocation)].nation);
				if(iNation == iCurrentNation)
				{
					return true;
				}
			}
		}
		return false;
	break;

	case "town_location":
		sLocation = refCharacter.location;
		iLocation = FindLocation(sLocation);
		if(iLocation != -1)
		{
			if(CheckAttribute(&Locations[iLocation], "fastreload"))
			{
				return true;
			}
		}
		return false;
	break;

	case "locator":
		if(refCharacter.location == condition.location)
		{
			locGroup = condition.locator_group;
			if( !CheckAttribute(refCharacter,"Quests.LocatorCheck."+locGroup) )
			{
				if(IsEntity(refCharacter))
				{
					refCharacter.Quests.LocatorCheck.(locGroup) = "";
					if( GetCharacterPos(refCharacter,&fx,&fy,&fz) )
					{
						if( CheckCurLocator(locGroup,condition.locator, fx,fy,fz) )
							refCharacter.Quests.LocatorCheck.(locGroup) = condition.locator;
					}
					AddCharacterLocatorGroup(refCharacter,locGroup);
				}
				else
				{
					Trace("character "+refCharacter.id+" not entity");
					return false;
				}
			}
			if(refCharacter.Quests.LocatorCheck.(locGroup)==condition.locator)	return true;
		}
		return false;
	break;
	case "NPC_Death":
		return CharacterIsDead(refCharacter);
	break;
	case "Nation_Ship_sink":
		return TestIntValue(GetNationShipKilled(refCharacter,condition.nation),sti(condition.quantity),condition.operation);
	break;
	case "Nation_Ship_Capture":
		return TestIntValue(GetNationShipCaptured(refCharacter,condition.nation),sti(condition.quantity),condition.operation);
	break;
	case "Class_Ship_sink":
		return TestIntValue(GetClassShipKilled(refCharacter,sti(condition.class)),sti(condition.quantity),condition.operation);
	break;
	case "Class_Ship_Capture":
		return TestIntValue(GetClassShipCaptured(refCharacter,sti(condition.class)),sti(condition.quantity),condition.operation);
	break;
	case "Time":
		return GetDayTime() == condition.time;
	break;
	case "TimeEx":
		return GetHour() >= sti(condition.time);
	break;
	case "Timer":
		if(GetDataYear() < sti(condition.date.year)) 
		{
			return false;
		}
		if(GetDataYear() > sti(condition.date.year)) 
		{
			return true;
		}
		if(GetDataMonth() < sti(condition.date.month)) 
		{
			return false;
		}
		if(GetDataMonth() > sti(condition.date.month)) 
		{
			return true;
		}
		if(GetDataDay() < sti(condition.date.day)) 
		{
			return false;
		}
		if(GetDataDay() > sti(condition.date.day)) 
		{
			return true;
		}
		if(GetHour() < sti(condition.date.hour)) 
		{
			return false;
		}
		if(GetHour() > sti(condition.date.hour)) 
		{
			return false;
		}
		return true;
	break;
	case "Ship_HP":
		return TestIntValue(GetCurrentShipHP(refCharacter),sti(condition.quantity),condition.operation);
	break;
	case "Quest":
		return CheckActiveQuest(condition.quest);
	break;
	case "Character_Capture":
		if( CheckAttribute(refCharacter,"Killer.status") && sti(refCharacter.Killer.status)==KILL_BY_ABORDAGE ) return true;
		return false;
	break;
	case "MapEnter":
		return IsEntity(worldMap);
	break;
	case "ExitFromLocation":
		return refCharacter.location != condition.location;
	break;
	case "Ship_location":
		if( CheckAttribute(refCharacter,"location.from_sea") && refCharacter.location.from_sea==condition.location ) return true;
		return false;
	break;
	case "Fort_destroy":
		if( CheckAttribute(refCharacter,"FortDestroy") && refCharacter.FortDestroy=="1" )
		{
			DeleteAttribute(refCharacter, "FortDestroy");
			return true;
		}
		return false;
	break;
	case "Fort_capture":
		if( CheckAttribute(refCharacter,"FortCapture") && refCharacter.FortCapture=="1" )
		{
			DeleteAttribute(refCharacter, "FortCapture");
			return true;
		}
		return false;
	break;
	case "Ship_capture":
		if(CheckAttribute(refCharacter,"ShipCapture") && refCharacter.ShipCapture=="1")
		{
			DeleteAttribute(refCharacter, "ShipCapture");
			return true;
		}
		return false;
	break;

	case "ComeToIsland":
		if(CheckAttribute(refCharacter,"ComeToIsland") && refCharacter.ComeToIsland=="1")
		{
			DeleteAttribute(refCharacter, "ComeToIsland");
			return true;
		}
		return false;
	break;
	
	case "EnterToSea":
		if(bSeaActive == true)
		{
			return true;
		}
		return false;
	break;

	case "ExitFromSea":
		if(bSeaActive == false)
		{
			return true;
		}
		return false;
	break;

	case "Group_Death":
		sTmpString = condition.group;
		aref grdeath; makearef(grdeath,refCharacter.GroupDeath);
		if( CheckAttribute(refCharacter,"GroupDeath."+sTmpString) && refCharacter.GroupDeath.(sTmpString)=="1" ) return true;
		return false;
	break;
	case "ActIntoLocator":
		if(refCharacter.location == condition.location)
		{
			locGroup = condition.locator_group;
			if( !CheckAttribute(refCharacter,"Quests.LocatorCheck."+locGroup) )
			{
				if(IsEntity(refCharacter))
				{
					refCharacter.Quests.LocatorCheck.(locGroup) = "";
					if( GetCharacterPos(refCharacter,&fx,&fy,&fz) )
					{
						if( CheckCurLocator(locGroup,condition.locator, fx,fy,fz) )
							refCharacter.Quests.LocatorCheck.(locGroup) = condition.locator;
					}
					AddCharacterLocatorGroup(refCharacter,locGroup);
				}
				else
				{
					Trace("character "+refCharacter.id+" not entity");
					return false;
				}
			}
			if(refCharacter.Quests.LocatorCheck.(locGroup)==condition.locator)
			{
				SetPossibleAction(refCharacter,condition,true);
			}
			else
			{
				SetPossibleAction(refCharacter,condition,false);
			}
		}
		return false;
	break;
	}
	trace("ERROR: unidentified condition type()" + condition);
	return false;
}

bool ProcessTimeCondition(aref condition)
{
	bool bTmp;
	int i;
	ref tmpRef;
	ref refCharacter;
	string sConditionName;
	string sTmpString;
	string locGroup;
	float fx,fy,fz;

	sConditionName = GetAttributeValue(condition);
	if(CheckAttribute(condition,"characterIdx"))
	{
		condition.character = sti(condition.characterIdx);
		DeleteAttribute(condition,"characterIdx");
	}
	if(CheckAttribute(condition,"character"))
	{
		refCharacter= GetCharacter(sti(condition.character));
		if(!CheckAttribute(refCharacter, "id"))
		{
			refCharacter = &characters[GetCharacterIndex(condition.character)];
		}
	}
	else
	{
		refCharacter = pchar;
	}

	switch (sConditionName)
	{
		case "timer":
			if(GetDataYear() < sti(condition.date.year)) 
			{
				return false;
			}
			if(GetDataYear() > sti(condition.date.year)) 
			{
				return true;
			}
			if(GetDataMonth() < sti(condition.date.month)) 
			{
				return false;
			}
			if(GetDataMonth() > sti(condition.date.month)) 
			{
				return true;
			}
			if(GetDataDay() < sti(condition.date.day)) 
			{
				return false;
			}
			if(GetDataDay() > sti(condition.date.day)) 
			{
				return true;
			}
			if(GetHour() < sti(condition.date.hour)) 
			{
				return false;
			}
			return true;
		break;

		case "TimeEx":
			return GetHour() >= sti(condition.time);
		break;

		case "MapEnter":
			return IsEntity(worldMap);
		break;
	}
	
	return false;
}

bool bQuestCheckProcess = false;

void QuestsCheck()
{
	if(bQuestCheckProcess) return;
	bQuestCheckProcess = true;
	aref quests;
	aref quest;
	aref conditions;
	aref condition;
	int  nQuestsNum;
	int  nConditionsNum;
	int  n,m;
	string sQuestName;
	bool bQuestCompleted;
	
	
	makearef(quests,pchar.quest);
		
	nQuestsNum = GetAttributesNum(quests);
	
	for(n = 0; n < nQuestsNum; n++)
	{
		quest = GetAttributeN(quests,n);

		sQuestName = GetAttributeName(quest);

		if(CheckAttribute(quest,"win_condition"))
		{
			if(quest.win_condition == "no")
			{
				// quest with no win condition; completed on first check
				OnQuestComplete(quest, sQuestName);
				nQuestsNum = GetAttributesNum(quests);
				continue;
			}
			makearef(conditions,quest.win_condition);
			nConditionsNum = GetAttributesNum(conditions);
			if(nConditionsNum == 0)
			{
				// quest with no win condition; completed on first check
				OnQuestComplete(quest, sQuestName);
				nQuestsNum = GetAttributesNum(quests);
				continue;
			}
			bQuestCompleted = true;
			for(m = 0; m < nConditionsNum; m++)
			{
				condition = GetAttributeN(conditions,m);
				if(ProcessCondition(condition) == false) 
				{
					bQuestCompleted = false;
					break;
				}
			}
			if(bQuestCompleted) 
			{
				OnQuestComplete(quest, sQuestName);
				nQuestsNum = GetAttributesNum(quests);
			}
		}
		
		if(CheckAttribute(quest,"fail_condition"))
		{
			makearef(conditions,quest.fail_condition);
			nConditionsNum = GetAttributesNum(conditions);
			if(nConditionsNum == 0) continue;
			for(m = 0; m < nConditionsNum; m++)
			{
				condition = GetAttributeN(conditions,m);
				if(ProcessCondition(condition) == true) 
				{
					OnQuestFailed(quest, sQuestName);
					nQuestsNum = GetAttributesNum(quests);
					break;
				}
			}
		}
	}

	for(n = 0; n < GetAttributesNum(quests); n++)
	{
		quest = GetAttributeN(quests,n);
		if(CheckAttribute(quest,"over") && quest.over=="yes")
		{
			// delete quests already completed or failed
			DeleteAttribute(quests,GetAttributeName(quest));
			n--;
		}
	}
	bQuestCheckProcess = false;
}

void QuestsTimeCheck()
{
	if(bQuestCheckProcess) return;
	bQuestCheckProcess = true;
	aref quests;
	aref quest;
	aref conditions;
	aref condition;
	int  nQuestsNum;
	int  nConditionsNum;
	int  n,m;
	string sQuestName;
	bool bQuestCompleted;
	
	checkForOverdueDebts();
	
	makearef(quests,pchar.quest);
		
	nQuestsNum = GetAttributesNum(quests);
	
	for(n = 0; n < nQuestsNum; n++)
	{
		quest = GetAttributeN(quests,n);

		sQuestName = GetAttributeName(quest);

		if(CheckAttribute(quest,"win_condition"))
		{
			if(quest.win_condition == "no")
			{
				// quest with no win condition; completed on first check
				OnQuestComplete(quest, sQuestName);
				nQuestsNum = GetAttributesNum(quests);
				continue;
			}
			makearef(conditions,quest.win_condition);
			nConditionsNum = GetAttributesNum(conditions);
			if(nConditionsNum == 0)
			{
				// quest with no win condition; completed on first check
				OnQuestComplete(quest, sQuestName);
				nQuestsNum = GetAttributesNum(quests);
				continue;
			}
			bQuestCompleted = true;
			for(m = 0; m < nConditionsNum; m++)
			{
				condition = GetAttributeN(conditions,m);
				if(ProcessTimeCondition(condition) == false) 
				{
					bQuestCompleted = false;
					break;
				}
			}
			if(bQuestCompleted) 
			{
				OnQuestComplete(quest, sQuestName);
				nQuestsNum = GetAttributesNum(quests);
			}
		}
		
		if(CheckAttribute(quest,"fail_condition"))
		{
			makearef(conditions,quest.fail_condition);
			nConditionsNum = GetAttributesNum(conditions);
			if(nConditionsNum == 0) continue;
			for(m = 0; m < nConditionsNum; m++)
			{
				condition = GetAttributeN(conditions,m);
				if(ProcessTimeCondition(condition) == true) 
				{
					OnQuestFailed(quest, sQuestName);
					nQuestsNum = GetAttributesNum(quests);
					break;
				}
			}
		}
	}

	for(n = 0; n < GetAttributesNum(quests); n++)
	{
		quest = GetAttributeN(quests,n);
		if(CheckAttribute(quest,"over") && quest.over=="yes")
		{
			// delete quests already completed or failed
			DeleteAttribute(quests,GetAttributeName(quest));
			n--;
		}
	}
	bQuestCheckProcess = false;
}

void OnQuestComplete(aref quest, string sQuestname)
{
	if(!CheckAttribute(quest,"over") && CheckAttribute(quest,"win_condition"))
	{
		quest.over = "yes";
		QuestComplete(quest.win_condition, sQuestName);
		StoryLineQuestComplete(quest.win_condition, sQuestName);
	}
}

void OnQuestFailed(aref quest, string sQuestName)
{
	if(CheckAttribute(quest,"fail_condition"))
	{
		quest.over = "yes";
		QuestComplete(quest.fail_condition, sQuestName);
		StoryLineQuestComplete(quest.fail_condition, sQuestName);
	}
}

void QC_DoUnloadLocation()
{
	DeleteAttribute(pchar,"GroupDeath");
	for(int n=1; n<MAX_CHARACTERS; n++)
	{
		DeleteAttribute(GetCharacter(n),"Quests.LocatorCheck");
	}
}

void SetPossibleAction(ref chref, aref condition, bool setting)
{
	if(setting)
	{
		if(CheckAttribute(condition,"act"))
		{
			condition.oldact = g_ActiveActionName;
			Log_SetActiveAction(condition.act);
		}
		chref.Quests.quest_act = GetAttributeName(condition);
	}
	else
	{
		if(CheckAttribute(condition,"oldact"))
		{
			Log_SetActiveAction(condition.oldact);
			DeleteAttribute(condition,"oldact");
		}
		DeleteAttribute(chref,"Quests.quest_act");
	}
}

int thisNewDay;

//Cerez: Check for overdue debts, notify the player, and deal out punishment
void checkForOverdueDebts()
{
	//Don't continue unless it is a new day (to save resources)
	if (thisNewDay != GetDataDay())
	{
		thisNewDay = GetDataDay();
	}
	else
	{
		return;
	}
	
	//Iterate through player loans, and process overdue loans
	aref loans;
	aref loanNum;
	string loanName;
	makearef(loans, pchar.quest.loans);
	int numLoans = GetAttributesNum(loans);
	bool isOverdue;
	int dueMonth;
	int dueYear;
	int dueDay;
	int curMonth = getDataMonth();
	int curYear = getDataYear();
	int curDay = getDataDay();
	int i;
	for (i = 0; i < numLoans; i++)
	{
		isOverdue = false;
		
		loanNum = GetAttributeN(loans, i);
		loanName = GetAttributeName(loanNum);
		
		//Do not process deactivated loans
		if (pchar.quest.loans.(loanName) == false)
		{
			continue;
		}
		
		//Get due date (with 1-7 added days of banker patience)
		dueMonth = makeint(pchar.quest.loans.(loanName).StartMonth) + makeint(pchar.quest.loans.(loanName).Period);
		dueYear = makeint(pchar.quest.loans.(loanName).StartYear);
		dueDay = makeint(pchar.quest.loans.(loanName).StartDay) + 3;
		if (dueMonth == 2 && dueDay > 28)
		{
			dueDay = 4;
			dueMonth++;
		}
		else
		{
			if (dueDay > 30)
			{
				dueDay = 1;
				dueMonth++;
			}
		}
		if (dueMonth > 12)
		{
			dueMonth = dueMonth - 12;
			dueYear++;
		}
		
		//Check if loan is overdue
		if (curYear > dueYear)
		{
			isOverdue = true;
		}
		else
		{
			if (curYear == dueYear)
			{
				if (curMonth > dueMonth)
				{
					isOverdue = true;
				}
				if (curMonth == dueMonth && curDay >= dueDay)
				{
					isOverdue = true;
				}
			}
		}
		
		//Deal out punishment
		if (isOverdue == true)
		{
			Log_SetStringToLog("You haven't paid your debt!");
			switch(pchar.quest.loans.(loanName).LoanNation)
			{
				case "Spain":
					ChangeCharacterReputation(pchar, -10, SPAIN);
					break;
				case "France":
					ChangeCharacterReputation(pchar, -10, FRANCE);
					break;
				case "England":
					ChangeCharacterReputation(pchar, -10, ENGLAND);
					break;
				case "Holland":
					ChangeCharacterReputation(pchar, -10, HOLLAND);
					break;
			}
			//Deactivate processed faulted loan
			pchar.quest.loans.(loanName) = false;
		}
	}
}
