#define I_MIN_MORALE	10

int FOOD_BY_CREW = 20 / iGameArcade;
int FOOD_BY_SLAVES = 8 / iGameArcade;
int FOOD_BY_PASSENGERS = 24 / iGameArcade;

bool bInterfaceFood = false;
int iFoodQuantity = 0;

void UpdateFood()
{	
	if (pchar.location == "")
	{		
		
		bInterfaceFood = true;
		CalculateFood();
		bInterfaceFood = false;
	}
}

void DecreaseMorale()
{
	int chrIndex = -1;
	int iCrewQuantity = 0;
	
	int iMorale = 0;
	int nMoraleDecreaseQ = 0;
	int nLeaderShip = 0;
	int nOrder;
	
	for (int i=0; i<COMPANION_MAX; i++)
	{
		chrIndex = GetCompanionIndex(pchar, i);
		if (chrIndex != -1)
		{
			iMorale = GetCharacterCrewMorale(&characters[chrindex]);
			nLeaderShip = characters[chrindex].skill.leadership;
			nOrder = i * 5;
			if(i == 0)
			{
				ChangeCharacterCrewMorale(&characters[chrindex], -10);
			}
			if (iFoodQuantity < 5)
			{
				if(iFoodQuantity == 0)
				{
					//LaunchFoodInfo();
					//DeleteAttribute(pchar, "foodinfo");
					
					if(CheckForRiot(&characters[chrIndex]) != 1)
					{
						LaunchFoodInfo();
						DeleteAttribute(pchar, "foodinfo");
					}
					else
					{
						PostEvent("ievent_Riot",nOrder,"sl","mutiny", chrIndex);
						isRiotActive = 1;
						return;
					}
					
				}
				else
				{
					if(!CheckAttribute(pchar, "foodinfo"))
					{
						//pchar.foodinfo = 1;
						//LaunchFoodInfo();
						
						if(CheckForRiot(&characters[chrIndex]) != 1)
						{
							pchar.foodinfo = 1;
							LaunchFoodInfo();
						}
						else
						{
							PostEvent("ievent_Riot",nOrder,"sl","mutiny", chrIndex);
							isRiotActive = 1;
							return;
						}
						
					}
				}
			}
			else
			{
				DeleteAttribute(pchar, "foodinfo");
			}
		}
	}
}

int CalculateFood()
{
	int chrIndex;
	int iCrewQuantity = 0;
	int foodNeeded = 0;
	int iSlavesQuantity = 0;
	iFoodQuantity = 0;

	for (int i=0; i<COMPANION_MAX; i++)
	{
		chrIndex = GetCompanionIndex(pchar, i);
		if (chrIndex != -1)
		{
			if(GetShipRemovable(&characters[chrIndex]) == true)
			{
				iCrewQuantity = sti(iCrewQuantity) + sti(characters[chrIndex].ship.crew.quantity);
				iFoodQuantity = iFoodQuantity + GetCargoGoods(&characters[chrIndex], GOOD_FOOD);
				iSlavesQuantity = iSlavesQuantity + GetCargoGoods(&characters[chrIndex], GOOD_SLAVES);
			}
		}
	}
	int iPassQuantity = GetPassengersQuantity(pchar);

	foodNeeded = iCrewQuantity/FOOD_BY_CREW + iPassQuantity/FOOD_BY_PASSENGERS + iSlavesQuantity/FOOD_BY_SLAVES;

	if(foodNeeded == 0)
	{
		foodNeeded = 1;
	}

	iFoodQuantity = iFoodQuantity/foodNeeded ;

	if(bInterfaceFood == true)
	{
		if (iFoodQuantity <= 0)
		{
			DecreaseMorale();
		}
		RemoveCharacterGoods(pchar, GOOD_FOOD, foodNeeded);
	}

	return iFoodQuantity;
}

int CalculateFoodEx(int addGood)
{
	int chrIndex;
	int iCrewQuantity = 0;
	int foodNeeded = 0;
	int iSlavesQuantity = 0;

	iFoodQuantity = 0;

	for (int i=0; i<COMPANION_MAX; i++)
	{
		chrIndex = GetCompanionIndex(pchar, i);
		if (chrIndex != -1)
		{
			if(GetShipRemovable(&characters[chrIndex]) == true)
			{
				iCrewQuantity = sti(iCrewQuantity) + sti(characters[chrIndex].ship.crew.quantity);
				iFoodQuantity = iFoodQuantity + GetCargoGoods(&characters[chrIndex], GOOD_FOOD);
				iSlavesQuantity = iSlavesQuantity + GetCargoGoods(&characters[chrIndex], GOOD_SLAVES);
			}
		}
	}
	int iPassQuantity = GetPassengersQuantity(pchar);

	foodNeeded = iCrewQuantity/FOOD_BY_CREW + iPassQuantity/FOOD_BY_PASSENGERS + iSlavesQuantity/FOOD_BY_SLAVES;

	if(foodNeeded == 0)
	{
		foodNeeded = 1;
	}

	iFoodQuantity = iFoodQuantity + addGood;

	iFoodQuantity = iFoodQuantity/foodNeeded ;

	if(bInterfaceFood == true)
	{
		if (iFoodQuantity <= 0)
		{
			DecreaseMorale();
		}
		RemoveCharacterGoods(pchar, GOOD_FOOD, foodNeeded);
	}

	return iFoodQuantity;
}
