#define	CST_QUESTTITLE	1
#define CST_QUESTTEXT	2

int curQuestTop;
int curRumourTop;

void InitInterface(string iniName)
{
	GameInterface.title = "titleQuestBook";

	SendMessage(&GameInterface,"ls",MSG_INTERFACE_INIT,iniName);

	XI_SetQuestData(true);

	SetEventHandler("InterfaceBreak","ProcessCancelExit",0);
	SetEventHandler("exitCancel","ProcessCancelExit",0);

	SetEventHandler("SetScrollerPos","SetScrollerPos",0);
	SetEventHandler("ScrollPosChange","ProcScrollPosChange",0);
	SetEventHandler("ScrollTopChange","ProcScrollChange",0);
	SetEventHandler("ievnt_command","ProcessCommandExecute",0);
	SetEventHandler("selectJournal","selectJournal",0);
	SetEventHandler("selectRumours","selectRumours",0);
	SetEventHandler("selectNations","selectNations",0);
	SetEventHandler("selectTradebook","selectTradebook",0);
	SetEventHandler("QuestTopChange","QuestTopChange",0);
	SetEventHandler("BackToTitle","BackToTitle",0);
	SetEventHandler("QuestActivate","XI_QuestActivate",0);
	SetEventHandler("QuestDeActivate","QuestDeActivate",0);
	SetEventHandler("RumourDeActivate","RumourDeActivate",0);
	
	SetSelectable("JOURNAL_BUTTON", false);
	SetNodeUsing("QUESTSCROLL",true);


	SetEventHandler("MouseRClickUp","HideInfoWindow",0);

	SetFormatedText("DESCRIBE1",XI_ConvertString("ENEMYRel"));
	SetFormatedText("DESCRIBE2",XI_ConvertString("FRIENDRel"));
	SetFormatedText("DESCRIBE3",XI_ConvertString("NEUTRALRel"));
	SetFormatedText("DESCRIBE4",XI_ConvertString("ALLIANCERel"));

	//FillLines();

	CreateImage("JOURNAL","JOURNAL_ICONS","JOURNAL",6,50,160,170);
	CreateImage("RUMOURS","JOURNAL_ICONS","RUMOURS",6,175,160,300);
	CreateImage("NATIONS","JOURNAL_ICONS","NATIONS",6,305,160,425);
	//CreateImage("TRADEBOOK","JOURNAL_ICONS","TRADEBOOK",6,430,160,555);

	EI_CreateFrame("JOURNAL_BORDERS",6,50,160,170);
	EI_CreateFrame("JOURNAL_BORDERS",6,175,160,300);
	EI_CreateFrame("JOURNAL_BORDERS",6,305,160,425);
	EI_CreateFrame("JOURNAL_BORDERS",6,430,160,555);


	SetNewPicture("MAIN_CHARACTER_PICTURE", "interfaces\portraits\128\face_" + pchar.FaceId + ".tga");


	CreateImage("ENGLAND","NATIONS","England",460,70,524,134);
	CreateImage("FRANCE","NATIONS","France",681,240,745,304);
	CreateImage("SPAIN","NATIONS","Spain",220,240,284,304);
	CreateImage("HOLLAND","NATIONS","Holland",317,470,381,534);
	CreateImage("PIRATE","NATIONS","Pirate",591,470,655,534);

	GameInterface.pictures.ENGLAND.pic = "";
	GameInterface.pictures.FRANCE.pic = "";
	GameInterface.pictures.SPAIN.pic = "";
	GameInterface.pictures.HOLLAND.pic = "";
	GameInterface.pictures.PIRATE.pic = "";

	if(sti(pchar.colony_quantity) == 0)
	{
		SetSelectable("COLONIES_BUTTON", false);
	}
	else
	{
		SetSelectable("COLONIES_BUTTON", true);
	}
	SetSelectable("SHIPS_BUTTON", IsEnableShipButton());


	SetFormatedText("CURRENT_DATE_TEXT", "");

	string sDate = " ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"CURRENT_DATE_CAPTION", 0,&sDate);

	sDate = environment.date.day + " " + XI_ConvertString("target_month_" + environment.date.month) + " " + environment.date.year;

	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"CURRENT_DATE_CAPTION", 0,&sDate);

	//Cerez: Fixed error in time display
	/* Ended up disabling the western time format, after fixing it, because the AM/PM looks ugly in the questbook interface. Left it here for anyone who wants it. */
	string sTime; 
	string sHour = sti(worldMap.date.hour);
	string sMinuts = sti(worldMap.date.min);
	string sAdd = "";
	/*
	if(LanguageGetLanguage() == "RUSSIAN")
	{
		*/
		if(sti(sHour) < 10)
		{
			sHour = "0" + sHour;
		}
		if(sti(sMinuts) < 10)
		{
			sMinuts = "0" + sMinuts;
		}
		
		sTime = sHour + " : " + sMinuts;
	/*
	}
	else
	{
		if(sti(sHour) > 12)
		{
			sHour = (sti(sHour) - 12);
			sAdd = " PM";
		}
		else
		{
			sAdd = " AM";
		}

		if(sti(sHour) < 10)
		{
			sHour = "0" + sHour;
		}
		if(sti(sMinuts) < 10)
		{
			sMinuts = "0" + sMinuts;
		}
		
		sTime = sHour + " : " + sMinuts + sAdd;
	}
	*/

	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"CURRENT_DATE_CAPTION", 0,&sTime);

	XI_RegistryExitKey("IExit_F2");
}

void XI_SetQuestData(bool qtitle)
{
	aref arefTmp;
	makearef(arefTmp,pchar.QuestInfo);

	XI_SetQuestTitles("QUEST_TITLE",arefTmp,0);
	curQuestTop = 0;
	
	SetNodeUsing("QUEST_TITLE",qtitle);
	SetNodeUsing("QUEST_TEXT",!qtitle);
	SetNodeUsing("QUESTSCROLL",true);

	
	//SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 1, "QUEST_TITLE");
	//SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "QUEST_TEXT");
	//SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "QUESTSCROLL");
	
	HideRumours();
	HideNations();
	HideTradeBook();
	ShowButtons();
	
	if(qtitle == true)
	{
		SetCurrentNode("QUEST_TITLE");
	}
	else
	{
		SetCurrentNode("QUEST_TEXT");
	}
}

void ShowButtons()
{
	SetNodeUsing("JOURNAL",true);
	SetNodeUsing("RUMOURS",true);
	SetNodeUsing("NATIONS",true);
	SetNodeUsing("TRADEBOOK",true);
	SetNodeUsing("CHARACTERS_BUTTON",true);
	SetNodeUsing("SHIPS_BUTTON",true);
	SetNodeUsing("JOURNAL_BUTTON",true);
	SetNodeUsing("COLONIES_BUTTON",true);
	SetNodeUsing("ITEMS_BUTTON",true);
	SetNodeUsing("EXIT_BTN",true);

	
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "JOURNAL");
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "RUMOURS");
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "TRADEBOOK");
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "NATIONS");
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "CHARACTERS_BUTTON");
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "SHIPS_BUTTON");
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "JOURNAL_BUTTON");
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "COLONIES_BUTTON");
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "ITEMS_BUTTON");
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "EXIT_BTN");

	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "RECTANGLE1");
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "RECTANGLE2");
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "RECTANGLE3");
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "RECTANGLE4");
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "RECTANGLE5");
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "RECTANGLE6");
}

void HideRumours()
{
	SetNodeUsing("RUMOUR_TITLE",false);
	SetNodeUsing("RUMOURSSCROLL",false);
}

void HideQuests()
{
	SetNodeUsing("QUEST_TITLE",false);
	SetNodeUsing("QUEST_TEXT",false);
	SetNodeUsing("QUESTSCROLL",false);
}

void XI_SetRumourData()
{
	aref arefTmp;

	XI_SetRumourTitles();
	curQuestTop = 0;
	
	SetNodeUsing("RUMOUR_TITLE",true);
	SetNodeUsing("RUMOURSSCROLL",true);
	
	//SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 1, "RUMOUR_TITLE");
	//SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "RUMOURSSCROLL");
	
	SetCurrentNode("RUMOUR_TITLE");
	HideQuests();
	HideNations();
	HideTradeBook();
	ShowButtons();
}

void XI_SetRumourTitles()
{
	string tmpStr;
	string sresult;
	SetFormatedText("RUMOUR_TITLE","");

	int m = 0;
	for(int i=RumoursQuantity-1; i>=0; i--)
	{
		if (checkAttribute(&Rumours[i], "questbook"))
		{
			sresult = rumours[i].date;
			SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"RUMOUR_TITLE", 0,&sresult);
			m = m + 1;

			sresult = rumours[i].text;
			SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"RUMOUR_TITLE", 0,&sresult);
			if(CheckAttribute(&Rumours[i], "isquest"))
			{
				SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"RUMOUR_TITLE", 8, (m-1), argb(255,255,192,255));
				SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"RUMOUR_TITLE", 8, m, argb(255,255,192,255));
			}
			m = m + 1;

			sresult = " ";
			SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"RUMOUR_TITLE", 0,&sresult);
			m = m + 1;
		}
	}
}

void ProcessCancelExit()
{
	if( GetSelectable("QUEST_TEXT") ) {
		XI_SetQuestData(true);
		return;
	}
	IDoExit(RC_INTERFACE_QUESTBOOK_EXIT);
}

void QuestTopChange()
{
	if( GetSelectable("QUEST_TITLE") )
	{
		int newTop = curQuestTop+GetEventData();

		aref arefTmp;
		makearef(arefTmp,pchar.QuestInfo);
		int maxVal = GetAttributesNum(arefTmp);
		if(newTop>=maxVal)
		{
			newTop=maxVal-1;
		}
		if(newTop<0)
		{
			newTop=0;
		}

		if(newTop!=curQuestTop)
		{
			curQuestTop=newTop;
			XI_SetQuestTitles("QUEST_TITLE",arefTmp,curQuestTop);
			XI_SetScroller(MakeFloat(newTop)/MakeFloat(maxVal));
		}
	}
}

void SetQTextShow(aref pA,int qnum)
{
	SendMessage(&GameInterface,"lsal",MSG_INTERFACE_INIT_QTEXT_SHOW,"QUEST_TEXT",pA,qnum);
	SetCurrentNode("QUEST_TEXT");
}

void BackToTitle()
{
	XI_SetQuestData(true);
}

void XI_QuestActivate()
{
	int aq = curQuestTop+GetEventData();
	aref pA;
	makearef(pA,pchar.QuestInfo);
	XI_SetQuestData(false);
	SetQTextShow(pA,aq);
	SetCurrentNode("QUEST_TEXT");
}

void XI_SetScroller(float pos)
{
	SendMessage(&GameInterface,"lsf",MSG_INTERFACE_SET_SCROLLER,"QUESTSCROLL",pos);
}

void SetScrollerPos()
{
	string nodName = GetEventData();
	float pos = GetEventData();
	XI_SetScroller(pos);
}

void IDoExit(int exitCode)
{
	DelEventHandler("InterfaceBreak","ProcessCancelExit");
	DelEventHandler("exitCancel","ProcessCancelExit");
	DelEventHandler("QuestTopChange","QuestTopChange");
	DelEventHandler("BackToTitle","BackToTitle");
	DelEventHandler("QuestActivate","XI_QuestActivate");
	DelEventHandler("SetScrollerPos","SetScrollerPos");
	DelEventHandler("ScrollPosChange","ProcScrollPosChange");
	DelEventHandler("ScrollTopChange","ProcScrollChange");
	DelEventHandler("ievnt_command","ProcessCommandExecute");
	DelEventHandler("selectJournal","selectJournal");
	DelEventHandler("selectRumours","selectRumours");
	DelEventHandler("selectTradebook","selectTradebook");
	DelEventHandler("selectNations","selectNations");

	DelEventHandler("MouseRClickUp","HideInfoWindow");

   interfaceResultCommand = exitCode;
	if( CheckAttribute(&InterfaceStates,"InstantExit") && sti(InterfaceStates.InstantExit)==true )
	{
		EndCancelInterface(true);
	}
	else
	{
		EndCancelInterface(true);
	}
}

void ProcScrollPosChange()
{
	float newPos = GetEventData();
	string scrollName = GetEventData();
	if( scrollName=="RUMOURSSCROLL" ) {return;}
	if( GetSelectable("QUEST_TITLE") )
	{
		aref arefTmp;
		makearef(arefTmp,pchar.QuestInfo);
		int maxVal = GetAttributesNum(arefTmp);
		int newTop = makeint(newPos*maxVal);

		if(newTop!=curQuestTop)
		{
			curQuestTop=newTop;
			XI_SetQuestTitles("QUEST_TITLE",arefTmp,curQuestTop);
		}
	}
	else
	{
		SendMessage(&GameInterface,"lslf",MSG_INTERFACE_MSG_TO_NODE,"QUEST_TEXT", 1,newPos);
	}
}

void ProcScrollChange()
{
	int changeNum = GetEventData();
	if(changeNum==0) return;
	string controlNode = "";
	if( GetSelectable("QUEST_TITLE") ) controlNode = "QUEST_TITLE";
	if( GetSelectable("QUEST_TEXT") ) controlNode = "QUEST_TEXT";

	if(controlNode!="")
	{
		if(changeNum>0) {
			SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,controlNode,-1, 0,ACTION_DOWNSTEP);
		} else {
			SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,controlNode,-1, 0,ACTION_UPSTEP);
		}
	}
}

void ProcessCommandExecute()
{
	string comName = GetEventData();
	string nodName = GetEventData();

	switch(nodName)
	{
	
	case "RECTANGLE1":

		trace(comName);
		if(comName=="rclick")
		{
			ShowInfoWindow(0);
		}
		break;
	case "RECTANGLE2":

		trace(comName);
		if(comName=="rclick")
		{
			ShowInfoWindow(1);
		}
		break;
	case "RECTANGLE3":

		trace(comName);
		if(comName=="rclick")
		{
			ShowInfoWindow(2);
		}
		break;
	case "RECTANGLE4":

		trace(comName);
		if(comName=="rclick")
		{
			ShowInfoWindow(3);
		}
		break;
	case "RECTANGLE5":

		trace(comName);
		if(comName=="rclick")
		{
			ShowInfoWindow(4);
		}
		break;
	case "RECTANGLE6":

		trace(comName);
		if(comName=="rclick")
		{
			ShowInfoWindow(5);
		}
		break;


	case "CHARACTERS_BUTTON":
		if(comName=="click")
		{
			
			IDoExit(RC_INTERFACE_TO_CHAR);
			return;
		}
	break;
	
	case "SHIPS_BUTTON":
		if(comName=="click")
		{
			
			IDoExit(RC_INTERFACE_TO_SHIP);
			return;
		}
	break;
	
	case "JOURNAL_BUTTON":
		if(comName=="click")
		{
			
			IDoExit(RC_INTERFACE_TO_LOGBOOK);
			return;
		}
	break;
	
	case "COLONIES_BUTTON":
		if(comName=="click")
		{
			
			IDoExit(RC_INTERFACE_TO_COLONY);
			return;
		}
	break;
	
	case "ITEMS_BUTTON":
		if(comName=="click")
		{
			
			IDoExit(RC_INTERFACE_TO_ITEMS);
			return;
		}
	break;

	}
}

void selectJournal()
{
	SetPictureBlind("JOURNAL", 1, BLIND_MIN, BLIND_MAX);
	SetPictureBlind("RUMOURS", 0, BLIND_MIN, BLIND_MAX);
	SetPictureBlind("TRADEBOOK", 0, BLIND_MIN, BLIND_MAX);
	SetPictureBlind("NATIONS", 0, BLIND_MIN, BLIND_MAX);
	XI_SetQuestData(true);
	//SetCurrentNode("QUESTSCROLL");
}

void selectRumours()
{
	SetPictureBlind("JOURNAL", 0, BLIND_MIN, BLIND_MAX);
	SetPictureBlind("RUMOURS", 1, BLIND_MIN, BLIND_MAX);
	SetPictureBlind("TRADEBOOK", 0, BLIND_MIN, BLIND_MAX);
	SetPictureBlind("NATIONS", 0, BLIND_MIN, BLIND_MAX);
	XI_SetRumourData();
	//SetCurrentNode("QUESTSCROLL");
}

void selectTradebook()
{
	SetPictureBlind("JOURNAL", 0, BLIND_MIN, BLIND_MAX);
	SetPictureBlind("RUMOURS", 0, BLIND_MIN, BLIND_MAX);
	SetPictureBlind("TRADEBOOK", 1, BLIND_MIN, BLIND_MAX);
	SetPictureBlind("NATIONS", 0, BLIND_MIN, BLIND_MAX);

	SetNodeUsing("LINES",true);

	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "LINES");
	HideQuests();
	HideRumours();
	HideNations();

	//1    = 1 
	//1    = 20.000 

	int iMoney = 0;
	int iPrevDaysCord = 200;
	int iPrevMoneyCord = 520;
	string sYear, sMonth;

	aref arYears, arMonths, arGraph;
	makearef(arYears, pchar.money.graph);
	
	//pchar.money.graph.1640.month1
	int iLeft,iTop,iRight,iBottom;

	int iYears = GetAttributesNum(arYears); //  
	
	for(int i = 0; i < iYears; i++)
	{
		arGraph = GetAttributeN(arYears, i);
		sYear = GetAttributeName(arGraph);
		for(int m = 0; m < 12; m++)
		{
			//sYear = its(i);
			sMonth = "month" + (m + 1);
			if(CheckAttribute(pchar, "money.graph." + sYear + "." + sMonth))
			{
				iMoney = sti(pchar.money.graph.(sYear).(sMonth));
				iMoney = iMoney/20000;
				iLeft = iPrevDaysCord;
				iTop = iPrevMoneyCord;
				iRight = iPrevDaysCord + 20;
				iBottom = 520 - iMoney;
				SendMessage( &GameInterface,"lsllllll",MSG_INTERFACE_MSG_TO_NODE,"LINES", 1, argb(255,255,255,192), iLeft,iTop,iRight,iBottom);
				iPrevDaysCord = iRight;
				iPrevMoneyCord = iBottom;
			}
		}
	}
	
}

void selectNations()
{
	SetPictureBlind("JOURNAL", 0, BLIND_MIN, BLIND_MAX);
	SetPictureBlind("RUMOURS", 0, BLIND_MIN, BLIND_MAX);
	SetPictureBlind("TRADEBOOK", 0, BLIND_MIN, BLIND_MAX);
	SetPictureBlind("NATIONS", 1, BLIND_MIN, BLIND_MAX);

	SetNodeUsing("DESCRIBE1",true);
	SetNodeUsing("DESCRIBE2",true);
	SetNodeUsing("DESCRIBE3",true);
	SetNodeUsing("DESCRIBE4",true);


	SetNodeUsing("FRAME1",true);
	SetNodeUsing("FRAME2",true);
	SetNodeUsing("FRAME3",true);
	SetNodeUsing("FRAME4",true);
	SetNodeUsing("FRAME5",true);
	SetNodeUsing("FRAME6",true);

	SetNodeUsing("RECTANGLE1",true);
	SetNodeUsing("RECTANGLE2",true);
	SetNodeUsing("RECTANGLE3",true);
	SetNodeUsing("RECTANGLE4",true);
	SetNodeUsing("RECTANGLE5",true);
	SetNodeUsing("RECTANGLE6",true);
	SetNodeUsing("LINE_ENGLAND_SPAIN",true);
	SetNodeUsing("LINE_ENGLAND_FRANCE",true);
	SetNodeUsing("LINE_FRANCE_PIRATE",true);
	SetNodeUsing("LINE_PIRATE_HOLLAND",true);
	SetNodeUsing("LINE_HOLLAND_SPAIN",true);
	SetNodeUsing("LINE_ENGLAND_HOLLAND",true);
	SetNodeUsing("LINE_ENGLAND_PIRATE",true);
	SetNodeUsing("LINE_FRANCE_SPAIN",true);
	SetNodeUsing("LINE_PIRATE_SPAIN",true);
	SetNodeUsing("LINE_FRANCE_HOLLAND",true);
	SetNodeUsing("LINE_ENGLAND_CHARACTER",true);
	SetNodeUsing("LINE_SPAIN_CHARACTER",true);
	SetNodeUsing("LINE_FRANCE_CHARACTER",true);
	SetNodeUsing("LINE_HOLLAND_CHARACTER",true);
	SetNodeUsing("LINE_PIRATE_CHARACTER",true);

	GameInterface.pictures.ENGLAND.pic = "England";
	GameInterface.pictures.FRANCE.pic = "France";
	GameInterface.pictures.SPAIN.pic = "Spain";
	GameInterface.pictures.HOLLAND.pic = "Holland";
	GameInterface.pictures.PIRATE.pic = "Pirate";



	SetNodeUsing("MAIN_CHARACTER_PICTURE",true);
	
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "MAIN_CHARACTER_PICTURE");

	SetCurrentNode("NATIONS");

	HideQuests();
	HideRumours();
	HideTradeBook();
	ShowButtons();

	//SendMessage(&GameInterface,"lslll", MSG_INTERFACE_MSG_TO_NODE, "LINES", 0, argb(255,255,0,0), -1);

	
	int iRelation = -1;
	int iColor;
	
	iRelation = GetNationRelation(ENGLAND, SPAIN);
	iColor = GetRelationColor(iRelation);
	SendMessage( &GameInterface, "lsll", MSG_INTERFACE_MSG_TO_NODE, "LINE_ENGLAND_SPAIN", 4, iColor);

	iRelation = GetNationRelation(ENGLAND, FRANCE);
	iColor = GetRelationColor(iRelation);
	SendMessage( &GameInterface, "lsll", MSG_INTERFACE_MSG_TO_NODE, "LINE_ENGLAND_FRANCE", 4, iColor);
	
	iRelation = GetNationRelation(FRANCE, PIRATE);
	iColor = GetRelationColor(iRelation);
	SendMessage( &GameInterface, "lsll", MSG_INTERFACE_MSG_TO_NODE, "LINE_FRANCE_PIRATE", 4, iColor);

	iRelation = GetNationRelation(HOLLAND, PIRATE);
	iColor = GetRelationColor(iRelation);
	SendMessage( &GameInterface, "lsll", MSG_INTERFACE_MSG_TO_NODE, "LINE_PIRATE_HOLLAND", 4, iColor);

	iRelation = GetNationRelation(SPAIN, HOLLAND);
	iColor = GetRelationColor(iRelation);
	SendMessage( &GameInterface, "lsll", MSG_INTERFACE_MSG_TO_NODE, "LINE_HOLLAND_SPAIN", 4, iColor);

	iRelation = GetNationRelation(ENGLAND, HOLLAND);
	iColor = GetRelationColor(iRelation);
	SendMessage( &GameInterface, "lsll", MSG_INTERFACE_MSG_TO_NODE, "LINE_ENGLAND_HOLLAND", 4, iColor);

	iRelation = GetNationRelation(ENGLAND, PIRATE);
	iColor = GetRelationColor(iRelation);
	SendMessage( &GameInterface, "lsll", MSG_INTERFACE_MSG_TO_NODE, "LINE_ENGLAND_PIRATE", 4, iColor);

	iRelation = GetNationRelation(SPAIN, FRANCE);
	iColor = GetRelationColor(iRelation);
	SendMessage( &GameInterface, "lsll", MSG_INTERFACE_MSG_TO_NODE, "LINE_FRANCE_SPAIN", 4, iColor);

	iRelation = GetNationRelation(SPAIN, PIRATE);
	iColor = GetRelationColor(iRelation);
	SendMessage( &GameInterface, "lsll", MSG_INTERFACE_MSG_TO_NODE, "LINE_PIRATE_SPAIN", 4, iColor);

	iRelation = GetNationRelation(FRANCE, HOLLAND);
	iColor = GetRelationColor(iRelation);
	SendMessage( &GameInterface, "lsll", MSG_INTERFACE_MSG_TO_NODE, "LINE_FRANCE_HOLLAND", 4, iColor);

	iRelation = GetNationRelation2MainCharacter(ENGLAND);
	iColor = GetRelationColor(iRelation);
	SendMessage( &GameInterface, "lsll", MSG_INTERFACE_MSG_TO_NODE, "LINE_ENGLAND_CHARACTER", 4, iColor);

	iRelation = GetNationRelation2MainCharacter(SPAIN);
	iColor = GetRelationColor(iRelation);
	SendMessage( &GameInterface, "lsll", MSG_INTERFACE_MSG_TO_NODE, "LINE_SPAIN_CHARACTER", 4, iColor);
	
	iRelation = GetNationRelation2MainCharacter(FRANCE);
	iColor = GetRelationColor(iRelation);
	SendMessage( &GameInterface, "lsll", MSG_INTERFACE_MSG_TO_NODE, "LINE_FRANCE_CHARACTER", 4, iColor);

	iRelation = GetNationRelation2MainCharacter(HOLLAND);
	iColor = GetRelationColor(iRelation);
	SendMessage( &GameInterface, "lsll", MSG_INTERFACE_MSG_TO_NODE, "LINE_HOLLAND_CHARACTER", 4, iColor);

	iRelation = GetNationRelation2MainCharacter(PIRATE);
	iColor = GetRelationColor(iRelation);
	SendMessage( &GameInterface, "lsll", MSG_INTERFACE_MSG_TO_NODE, "LINE_PIRATE_CHARACTER", 4, iColor);
	
}

int GetRelationColor(int iRelation)
{
	int iResult = argb(255,128,128,128);
	switch (iRelation)
	{
		case RELATION_ENEMY:
			iResult = argb(255,255,128,128);
		break;
		case RELATION_FRIEND:
			iResult = argb(255,128,192,128);
		break;
		case RELATION_NEUTRAL:
			iResult = argb(255,128,128,128);
		break;
		case RELATION_ALLIANCE:
			iResult = argb(255,128,128,192);
		break;
	}

	return iResult;
}

void HideNations()
{
	SetNodeUsing("BIG_NATION",false);
	SetNodeUsing("DESCRIBE1",false);
	SetNodeUsing("DESCRIBE2",false);
	SetNodeUsing("DESCRIBE3",false);
	SetNodeUsing("DESCRIBE4",false);

	SetNodeUsing("FRAME1",false);
	SetNodeUsing("FRAME2",false);
	SetNodeUsing("FRAME3",false);
	SetNodeUsing("FRAME4",false);
	SetNodeUsing("FRAME5",false);
	SetNodeUsing("FRAME6",false);

	SetNodeUsing("RECTANGLE1",false);
	SetNodeUsing("RECTANGLE2",false);
	SetNodeUsing("RECTANGLE3",false);
	SetNodeUsing("RECTANGLE4",false);
	SetNodeUsing("RECTANGLE5",false);
	SetNodeUsing("RECTANGLE6",false);

	SetNodeUsing("LINE_ENGLAND_SPAIN",false);
	SetNodeUsing("LINE_ENGLAND_FRANCE",false);
	SetNodeUsing("LINE_FRANCE_PIRATE",false);
	SetNodeUsing("LINE_PIRATE_HOLLAND",false);
	SetNodeUsing("LINE_HOLLAND_SPAIN",false);
	SetNodeUsing("LINE_ENGLAND_HOLLAND",false);
	SetNodeUsing("LINE_ENGLAND_PIRATE",false);
	SetNodeUsing("LINE_FRANCE_SPAIN",false);
	SetNodeUsing("LINE_PIRATE_SPAIN",false);
	SetNodeUsing("LINE_FRANCE_HOLLAND",false);
	SetNodeUsing("LINE_ENGLAND_CHARACTER",false);
	SetNodeUsing("LINE_SPAIN_CHARACTER",false);
	SetNodeUsing("LINE_FRANCE_CHARACTER",false);
	SetNodeUsing("LINE_HOLLAND_CHARACTER",false);
	SetNodeUsing("LINE_PIRATE_CHARACTER",false);

	GameInterface.pictures.ENGLAND.pic = "";
	GameInterface.pictures.FRANCE.pic = "";
	GameInterface.pictures.SPAIN.pic = "";
	GameInterface.pictures.HOLLAND.pic = "";
	GameInterface.pictures.PIRATE.pic = "";

	SetNodeUsing("MAIN_CHARACTER_PICTURE",false);
}

void HideTradeBook()
{
	SetNodeUsing("LINES",false);
}


void HideInfoWindow() 
{
	/*XI_WindowShow("INFO_WINDOW", false);	
	XI_WindowDisable("INFO_WINDOW", true);
	XI_WindowDisable("MAIN_WINDOW", false);*/
	CloseTooltip();
};

void ShowInfoWindow(int index) 
{
	/*XI_WindowDisable("MAIN_WINDOW", true);
	XI_WindowDisable("INFO_WINDOW", false);
	XI_WindowShow("INFO_WINDOW", true);

	SetFormatedText("INFO_WINDOW_DESCRIBE_CAPTION", "");
	SetFormatedText("INFO_WINDOW_DESCRIBE", "");


	switch (index)
	{
	case 0:

		SetFormatedText("INFO_WINDOW_CAPTION", XI_ConvertString("Spain"));
		break;
	case 1:

		SetFormatedText("INFO_WINDOW_CAPTION", XI_ConvertString("England"));
		break;
	case 2:

		SetFormatedText("INFO_WINDOW_CAPTION", XI_ConvertString("Holland"));
		break;
	case 3:
		SetFormatedText("INFO_WINDOW_CAPTION", XI_ConvertString("titleCharacter"));
		break;
	case 4:
		SetFormatedText("INFO_WINDOW_CAPTION", XI_ConvertString("France"));
		break;
	case 5:

		SetFormatedText("INFO_WINDOW_CAPTION", XI_ConvertString("Pirate"));
		break;

		//INFO_WINDOW_DESCRIBE_CAPTION
	}

	*/

	string sHeader = "";
	string sGroupPicture = "";
	string sPicture = "";

	string sText1 = "";

	switch (index)
	{
		case 0:
			sHeader =  XI_ConvertString("Spain"));
			sGroupPicture = "Spain";
		break;

		case 1:
			sHeader =  XI_ConvertString("England"));
			sGroupPicture = "England";
		break;

		case 2:
			sHeader =  XI_ConvertString("Holland"));
			sGroupPicture = "Holland";
			break;
		case 3:
			sHeader = GetCharacterFullName(pchar.id);
			sGroupPicture = "";
			sPicture = "interfaces\portraits\64\face_" + pchar.FaceId + ".tga";
			sText1 = XI_convertString("It's you");
		break;

		case 4:
			sHeader =  XI_ConvertString("France"));
			sGroupPicture = "France";
		break;

		case 5:
			sHeader =  XI_ConvertString("Pirate"));
			sGroupPicture = "Pirate";
		break;
	}

	CreateTooltip("#" + sHeader, sText1, argb(255,255,255,255), "", argb(255,255,255,255), "", argb(255,192,255,192), "", argb(255,255,255,255), sPicture, "NATIONS", sGroupPicture, 64, 64);
};

void QuestDeActivate()
{
	XI_SetQuestData(true);
}

void RumourDeActivate()
{
	XI_SetRumourData();
}
