
void LAi_CreateCommander (aref chr)
{
	LAi_SetGuardianType(chr);
	
	int group = sti(chr.nation);
	string sgroup = GetNationNameByType(group)  + "_soldier";
	LAi_group_MoveCharacter(chr, sgroup);
	
	// 
	LAi_SetLevelHP(chr);
	LAi_NPC_Equip(chr, chr.rank, true, true);
}

void LAi_SetLevelHP(aref chr)
{
	int hp = 10 + sti(chr.rank) * 3;
	if(CheckCharacterPerk(chr, "HardMan"))
	{
		hp = hp * 1.5;
	}
	if(!CheckAttribute(chr, "id"))
	{
		trace("character "  + chr.index + " have no ID");
	}
	if(CheckAttribute(pchar, "id"))
	{
		if(chr.id == pchar.id)
		{
			hp = hp * (0.8 + (0.2 * iGameArcade));
		}
	}
	chr.chr_ai.hp = hp;
	chr.chr_ai.hp_max = hp;
}

void LAi_SetLevelHPPlus(aref chr)
{
	int hp = 2;
	chr.chr_ai.hp = sti(chr.chr_ai.hp) + hp;
	chr.chr_ai.hp_max = sti(chr.chr_ai.hp_max) + hp;
}

void LAi_SetBoardingCaptainLevelHP(aref chr)
{
	int hp = 10 + sti(chr.rank) * 2;
	hp = hp * (1.0 + (0.1 * (5 - iGameArcade)));
	int iMorale = sti(chr.ship.crew.morale) / 2;
	hp = hp + iMorale;
	int iExperience = sti(chr.ship.crew.experience) / 4;
	hp = hp + iExperience;
	chr.chr_ai.hp = hp;
	chr.chr_ai.hp_max = hp;
}

void CreateCitizens(aref loc)
{
	if(CheckAttribute(pchar, "isload"))
	{
		//     /
		DeleteAttribute(pchar, "isload");
		return;
	}

	int iColony = -1;
	int iNation = -1;
	if(CheckAttribute(loc, "fastreload"))
	{
		iColony = FindColony(loc.fastreload);
	}
	if(iColony == -1)
	{
		return;
	}
	
	iNation = SetNation(iColony);
	
	if(iNation == -1)
	{
		return;
	}

	bool isRealCitizen = true;

	int iCitizensQuantity, iModel;
	ref chr;
	string sLocator;
	string sDialogFile;
	string sModel, sAnimation;
		
	int iChar, i, group;
	string slai_group, slai_group2;

	if (checkAttribute(loc, "citizens"))
	{
		if (sti(Environment.date.hour) > 5 && sti(Environment.date.hour) < 19 && !Whr_IsRain())
		{
			int iPlanter = rand(8);
			if(iPlanter == 1 && LAi_IsCapturedLocation == 0 && iNation != PIRATE)
			{
				iChar = GenerateCharacter(iNation, WITHOUT_SHIP, "citizen", MAN, 1, TRADER);
				chr = &characters[iChar];
				LAi_SetLoginTime(chr, 6.0, 18.99);
				PlaceCharacter(chr, "goto", "random");

				if(!CheckAttribute(chr, "quest.questflag"))
				{
					chr.quest.questflag = GenerateSlavesQuest(chr);
				}

				LAi_NPC_Equip(chr, chr.rank, true, false);
				LAi_SetCitizenType(chr);

				group = sti(chr.nation);
				slai_group = GetNationNameByType(group)  + "_citizens";
				LAi_group_MoveCharacter(chr, slai_group);
				slai_group2 = GetNationNameByType(group)  + "_soldiers";
				LAi_group_SetRelation(slai_group, slai_group2, LAI_GROUP_FRIEND);
		
				if(sti(chr.quest.questflag) != -1)
				{
					chr.dialog.filename = "Planter_dialog.c";
					chr.dialog.currentnode = "first time";
					chr.greeting = "cit_quest_" + (rand(3) + 1);
				}
				else
				{
					chr.dialog.filename = "Citizen_dialog.c";
					chr.dialog.currentnode = "first time";
					if(chr.sex == "man")
					{
						chr.greeting = "cit_common_" + (rand(3) + 1);
					}
					else
					{
						chr.greeting = "whore_blaze_2";
					}
				}
				LAi_SetLevelHP(chr);
			}

			iCitizensQuantity = rand(8) + 6;
			//int m = 0;
			for(i=0; i<iCitizensQuantity; i++)
			{
				if(iNation != PIRATE)
				{
					iChar = GenerateCharacter(iNation, WITHOUT_SHIP, "citizen", rand(WOMAN), 0, CITIZEN);
				}
				else
				{
					iChar = GenerateCharacter(iNation, WITHOUT_SHIP, "pirate", MAN, 0, CITIZEN);
				}
				chr = &characters[iChar];
				if(!CheckAttribute(chr, "quest.questflag") && iNation != PIRATE && LAi_IsCapturedLocation == 0 && chr.sex == "man")
				{
					int isQuest = rand(15);
					if(isQuest == 1)
					{
						chr.quest.questflag = GeneratePassengerQuest(chr, 0, "", 0, rand(1), 0, 0);
					}
				}

				LAi_SetLoginTime(chr, 6.0, 18.99);
				
				if (sti(chr.nation) == PIRATE)
				{
					LAi_NPC_Equip(chr, chr.rank, true, false);
					LAi_SetWarriorType(chr);
					LAi_warrior_DialogEnable(chr, true);
				}
				else
				{
					if(chr.sex == "man")
					{
						LAi_NPC_Equip(chr, chr.rank, true, false);
					}
					else
					{
						//chr.id = "woman_" + m;
						//m++;
						DeleteAttribute(chr, "items");
						DeleteAttribute(chr, "equip");
					}
					LAi_SetCitizenType(chr);
				}

				if(LAi_IsCapturedLocation)
				{
					chr.location.loadcapture = 1;
					LAi_SetActorType(chr);
					LAi_ActorSetLayMode(chr);
					LAi_SetImmortal(chr, 1);
					LAi_group_MoveCharacter(chr, LAI_GROUP_PLAYER);
				}
				else
				{
					isRealCitizen = true;
					if(sti(Colonies[iColony].capture_flag) == 1)
					{
						LAi_group_MoveCharacter(chr, LAI_GROUP_PLAYER);
						isRealCitizen = false;
					}
					if(isRealCitizen == true)
					{
						group = sti(chr.nation);
						slai_group = GetNationNameByType(group)  + "_citizens";
						LAi_group_MoveCharacter(chr, slai_group);
						slai_group2 = GetNationNameByType(group)  + "_soldiers";
						LAi_group_SetRelation(slai_group, slai_group2, LAI_GROUP_FRIEND);
					}
				}

				PlaceCharacter(chr, "goto", "random");

				chr.dialog.filename = "Citizen_dialog.c";
				if(chr.sex == "man")
				{
					chr.dialog.currentnode = SelectTutorial();
					if(chr.dialog.currentnode != "First Time")
					{
						chr.tutorial.link = chr.dialog.currentnode;
						chr.quest.questflag.model = "";
						if(CheckAttribute(&InterfaceStates,"EnabledQuestsMarks") )
						{
							if(sti(InterfaceStates.EnabledQuestsMarks) == 1 && LAi_IsCapturedLocation == false)
							{
								chr.quest.questflag.model = "questionmarkI";
								chr.quest.questflag.technique = GetTechNameForSign();
							}
						}
					}
				}
				else
				{
					chr.dialog.currentnode = "first time";
				}

				if(sti(chr.nation) == PIRATE)
				{
					chr.greeting = "pirat_common_" + (rand(3) + 1);
				}
				else
				{
					if(chr.sex == "man")
					{
						chr.greeting = "cit_common_" + (rand(3) + 1);
					}
					else
					{
						chr.greeting = "whore_blaze_2";
					}
				}
				LAi_SetLevelHP(chr);
				
			}
		}
	}

	aref st;
	if (checkAttribute(loc, "locators.merchant"))
	{
		if(LAi_IsCapturedLocation == 0)
		{
			
			if (sti(Environment.date.hour) > 5 && sti(Environment.date.hour) < 17)
			{
				makearef(st, loc.locators.merchant);
				iCitizensQuantity = GetAttributesNum(st) / 2;
				for(i=0; i<iCitizensQuantity; i++)
				{
					iChar = GenerateCharacter(iNation, WITHOUT_SHIP, "citizen", MAN, 0, CITIZEN);
					chr = &characters[iChar];
					LAi_SetLoginTime(chr, 6.0, 16.99);

					//PlaceCharacter(chr, "merchant", "random");
					ChangeCharacterAddressGroup(chr, loc.id, "merchant", "merchant"+(i+1));
					LAi_SetMerchantType(chr);
					chr.dialog.filename = "Merchant_dialog.c";
					chr.dialog.currentnode = "first time";
					chr.greeting = "tra_common_" + (rand(3) + 1);
					GiveItemToTrader(chr);

					LAi_SetLevelHP(chr);

					group = sti(chr.nation);
					slai_group = GetNationNameByType(group)  + "_citizens";
					LAi_group_MoveCharacter(chr, slai_group);
					slai_group2 = GetNationNameByType(group)  + "_soldiers";
					LAi_group_SetRelation(slai_group, slai_group2, LAI_GROUP_FRIEND);
				}
			}
		}
	}
	if (checkAttribute(loc, "soldiers") && CheckAttribute(loc, "locators.soldiers"))
	{
		if(LAi_IsCapturedLocation)
		{
			
			makearef(st, loc.locators.soldiers);
			iCitizensQuantity = GetAttributesNum(st);
			for(i=0; i<iCitizensQuantity; i++)
			{
				if(iNation != PIRATE)
				{
					iChar = GenerateCharacter(iNation, WITHOUT_SHIP, "soldier", MAN, 0, SOLDIER);
				}
				else
				{
					iChar = GenerateCharacter(iNation, WITHOUT_SHIP, "pirate", MAN, 0, SOLDIER);
				}
				chr = &characters[iChar];

				LAi_NPC_Equip(chr, chr.rank, true, false);
				LAi_CharacterReincarnation(chr, true, true);

				LAi_SetLoginTime(chr, 0.0, 24.0);

				PlaceCharacter(chr, "soldiers", "random");
				
				LAi_SetGuardianType(chr);

				if(LAi_IsCapturedLocation == 0)
				{
					isRealCitizen = true;
					if(sti(Colonies[iColony].capture_flag) == 1)
					{
						LAi_group_MoveCharacter(chr, LAI_GROUP_PLAYER);
						isRealCitizen = false;
						chr.greeting = "pirat_guard_" + (rand(3) + 1);
					}
					if(isRealCitizen == true)
					{
						group = sti(chr.nation);
						slai_group = GetNationNameByType(group)  + "_citizens";
						slai_group2 = GetNationNameByType(group)  + "_soldiers";
						LAi_group_MoveCharacter(chr, slai_group2);
						LAi_group_SetRelation(slai_group, slai_group2, LAI_GROUP_FRIEND);
						chr.greeting = "soldier_common_" + (rand(3) + 1);
					}
				}
				else
				{
					LAi_group_MoveCharacter(chr, LAI_GROUP_PLAYER);
					chr.location.loadcapture = 1;
					chr.greeting = "pirat_guard_" + (rand(3) + 1);

				}

				chr.dialog.filename = "Soldier_dialog.c";
				chr.dialog.currentnode = "first time";


				LAi_SetLevelHP(chr);
			}
		}
	}
	if (checkAttribute(loc, "soldiers") && CheckAttribute(loc, "locators.patrol"))
	{
		ColoniesInfoUpdate();
		makearef(st, loc.locators.patrol);
		iCitizensQuantity = GetAttributesNum(st);
		if(iCitizensQuantity > 5)
		{
			iCitizensQuantity = iCitizensQuantity/2;
		}
		for(i=0; i<iCitizensQuantity; i++)
		{
			if(iNation != PIRATE && LAi_IsCapturedLocation == 0)
			{
				iChar = GenerateCharacter(iNation, WITHOUT_SHIP, "soldier", MAN, 0, WARRIOR);
			}
			else
			{
				iChar = GenerateCharacter(iNation, WITHOUT_SHIP, "pirate", MAN, 0, WARRIOR);
			}
			chr = &characters[iChar];

			LAi_NPC_Equip(chr, chr.rank, true, false);
			LAi_CharacterReincarnation(chr, true, true);

			LAi_SetLoginTime(chr, 0.0, 24.0);
	
			LAi_SetPatrolType(chr);
			
			if(LAi_IsCapturedLocation == 0)
			{
				isRealCitizen = true;
				if(sti(Colonies[iColony].capture_flag) == 1)
				{
					LAi_group_MoveCharacter(chr, LAI_GROUP_PLAYER);
					isRealCitizen = false;
					chr.greeting = "pirat_guard_" + (rand(3) + 1);
				}
				if(isRealCitizen == true)
				{
					group = sti(chr.nation);
					slai_group = GetNationNameByType(group)  + "_citizens";
					slai_group2 = GetNationNameByType(group)  + "_soldiers";
					LAi_group_MoveCharacter(chr, slai_group2);
					LAi_group_SetRelation(slai_group, slai_group2, LAI_GROUP_FRIEND);
					chr.greeting = "soldier_common_" + (rand(3) + 1);
				}
			}
			else
			{
				LAi_group_MoveCharacter(chr, LAI_GROUP_PLAYER);
				chr.location.loadcapture = 1;
				chr.greeting = "pirat_guard_" + (rand(3) + 1);
			}

			PlaceCharacter(chr, "patrol", "random");

			chr.dialog.filename = "Patrol_dialog.c";
			chr.dialog.currentnode = "first time";
			LAi_SetLevelHP(chr);
		}
	}
}


void CreateHabitues (aref loc)
{
	if(CheckAttribute(pchar, "isload"))
	{
		//     /
		DeleteAttribute(pchar, "isload");
		return;
	}

	if(LAi_IsCapturedLocation)
	{
		return;
	}		

	int iColony = -1;
	int iNation = -1;

	if(!CheckAttribute(loc, "fastreload"))
	{
		return;
	}

	iColony = FindColony(loc.fastreload);

	if(iColony == -1)
	{
		return;
	}
	
	iNation = SetNation(iColony);
	
	if(iNation == -1)
	{
		return;
	}

	string sColony = loc.fastreload;
	int iCitizensQuantity, iModel;
	ref chr;
	string sLocator;
	string sDialogFile;
	string sModel, sAnimation;

	int iChar;

	if(CheckAttribute(pchar, "colonyinfoon") && checkAttribute(loc, "habitues"))
	{
		iChar = GenerateCharacter(iNation, WITHOUT_SHIP, "citizen", MAN, 0, CITIZEN);
		chr = &characters[iChar];
		characters[iChar].dialog.type = rand(12);
		PlaceCharacter(chr, "sit", "random");
			
		LAi_SetLoginTime(chr, 0.0, 24.0);

		LAi_SetSitType(chr);
		
		int mangroup = sti(chr.nation);
		string manslai_group = GetNationNameByType(mangroup)  + "_citizens";
		LAi_group_MoveCharacter(chr, manslai_group);
		string manslai_group2 = GetNationNameByType(mangroup)  + "_soldiers";
		LAi_group_SetRelation(manslai_group, manslai_group2, LAI_GROUP_FRIEND);
		
		chr.dialog.filename = "Habitue_dialog.c";
		chr.dialog.currentnode = "colony_Info_Time";
		chr.greeting = "cit_common_" + (rand(3) + 1);
	}

	
	if (checkAttribute(loc, "habitues"))
	{
		int iRanger = FindRangerOnColony(sColony);
		if(iRanger != -1)
		{
			PlaceCharacter(&characters[iRanger], "sit", "random");
			LAi_SetSitTypeNoGroup(&characters[iRanger]);
			characters[iRanger].Dialog.Filename = "Ranger_dialog.c";
			characters[iRanger].Dialog.CurrentNode = "First time";
			LAi_SetLoginTime(chr, 0.0, 24.0);
		}

		int isPresentCompanion = 0;
		int iChanseToMeetCompanion = 40;
		int iIsMeetCompanion = rand(100);
		if(iChanseToMeetCompanion >= iIsMeetCompanion)
		{
			isPresentCompanion = 1;
		}
		iCitizensQuantity = rand(2) + 3;

		int group;
		string slai_group;
		string slai_group2;
		int isPresentSmuggler = 1;
		if(colonies[FindColony(sColony)].capture_flag == 1)
		{
			isPresentSmuggler = 0;
		}
		if(CheckAttribute(pchar, "smuggling_for_colony_" + sColony))
		{
			isPresentSmuggler = 0;
		}
		/*if(LanguageGetLanguage() != "Russian")
		{
			isPresentSmuggler = 0;
		}*/
		for(int i=0; i<iCitizensQuantity; i++)
		{
			if(isPresentSmuggler == 1)
			{
				isPresentSmuggler = 0;
				iChar = GenerateCharacter(iNation, WITH_SHIP, "pirate", MAN, 0, TRADER);
				chr = &characters[iChar];
				chr.model = "pirate_2";
				LAi_RemoveLoginTime(chr);
				PlaceCharacter(chr, "sit", "random");

				LAi_NPC_Equip(chr, chr.rank, true, false);
				LAi_SetSitType(chr);

				group = sti(chr.nation);
				slai_group = GetNationNameByType(group)  + "_citizens";
				LAi_group_MoveCharacter(chr, slai_group);
				slai_group2 = GetNationNameByType(group)  + "_soldiers";
				LAi_group_SetRelation(slai_group, slai_group2, LAI_GROUP_FRIEND);

				chr.Dialog.Filename = "Smuggler_dialog.c";
				if(!CheckAttribute(pchar, "smuggler_tutorial_complete"))
				{
					chr.Dialog.CurrentNode = "Smuggler_tutorial";
					chr.quest.questflag.model = "";
					if(CheckAttribute(&InterfaceStates,"EnabledQuestsMarks") )
					{
						if(sti(InterfaceStates.EnabledQuestsMarks) == 1)
						{
							chr.tutorial = 1;
							chr.quest.questflag.model = "questionmarkI";
							chr.quest.questflag.technique = GetTechNameForSign();
						}
					}
				}
				else
				{
					if(CheckForContraband(chr) == true)
					{
						chr.Dialog.CurrentNode = "Smuggler_offer";
					}
					else
					{
						chr.Dialog.CurrentNode = "Smuggler_nothing";
					}
				}
				chr.greeting = "cit_quest_" + (rand(3) + 1);
			}

			if(isPresentCompanion == 1)
			{
				isPresentCompanion = 0;
				iChar = GenerateCharacter(iNation, WITH_SHIP, "trader", MAN, 1, TRADER);
				chr = &characters[iChar];
				LAi_RemoveLoginTime(chr);
				PlaceCharacter(chr, "sit", "random");

				if(!CheckAttribute(chr, "quest.questflag"))
				{
					chr.quest.questflag = GenerateEscortQuest(chr, 0, "", 0, 0, 0, 0);
				}

				LAi_NPC_Equip(chr, chr.rank, true, false);
				LAi_SetSitType(chr);

				group = sti(chr.nation);
				slai_group = GetNationNameByType(group)  + "_citizens";
				LAi_group_MoveCharacter(chr, slai_group);
				slai_group2 = GetNationNameByType(group)  + "_soldiers";
				LAi_group_SetRelation(slai_group, slai_group2, LAI_GROUP_FRIEND);
		
				if(sti(chr.quest.questflag) != -1)
				{
					chr.Dialog.Filename = "Enc_companion_dialog.c";
					chr.Dialog.CurrentNode = "SelectOffer";
					chr.greeting = "cit_quest_" + (rand(3) + 1);
				}
				else
				{
					chr.dialog.filename = "Habitue_dialog.c";
					chr.dialog.currentnode = "first time";
					chr.greeting = "cit_common_" + (rand(3) + 1);
				}
				LAi_SetLevelHP(chr);
			}
			else
			{
				iChar = GenerateCharacter(iNation, WITHOUT_SHIP, "citizen", MAN, 0, CITIZEN);
				chr = &characters[iChar];
				characters[iChar].dialog.type = rand(12);
				PlaceCharacter(chr, "sit", "random");
					
				LAi_SetLoginTime(chr, 0.0, 24.0);

				LAi_SetSitType(chr);
				
				group = sti(chr.nation);
				slai_group = GetNationNameByType(group)  + "_citizens";
				LAi_group_MoveCharacter(chr, slai_group);
				slai_group2 = GetNationNameByType(group)  + "_soldiers";
				LAi_group_SetRelation(slai_group, slai_group2, LAI_GROUP_FRIEND);
				
				chr.dialog.filename = "Habitue_dialog.c";
				chr.dialog.currentnode = "first time";
				chr.greeting = "cit_common_" + (rand(3) + 1);
			}
		}
	}	

}

int SetNation(int iColony)
{
	if(colonies[iColony].id == "IslaMona")
	{
		return PIRATE;
	}
	if(colonies[iColony].nation == "none")
	{
		return -1;
	}
	return sti(Colonies[iColony].nation);
}

string LAi_FindFreeRandomLocator(string group)
{
	if(IsEntity(loadedLocation) != true) return "";
	string at = "locators." + group;
	if(CheckAttribute(loadedLocation, at) == 0) return "";
	aref grp;
	makearef(grp, loadedLocation.(at));
	int num = GetAttributesNum(grp);
	if(num <= 0) return "";
	int base = rand(num - 1);
	for(int i = 0; i < num; i++)
	{
		int index = base + i;
		if(index >= num)
		{
			index = index - num;
		}
		aref loc = GetAttributeN(grp, index);
		float lx = stf(loc.x);
		float ly = stf(loc.y);
		float lz = stf(loc.z);
		if(CheckLocationPosition(loadedLocation, lx, ly, lz))
		{
			return GetAttributeName(GetAttributeN(grp, index));
		}
	}
	return "";
}

int LAi_FindNearestNotCompanionCharacter(aref chr, float radius)
{
	
	int res = FindNearCharacters(chr, radius, -1.0, -1.0, 0.01, false, true);
	if(res < 0) return -1;
	
	for (int i =0; i<res; i++)
	{
		if (!IsOfficer(&characters[sti(chrFindNearCharacters[i].index)]))
		{
			return sti(chrFindNearCharacters[i].index);
		}
	}
	
	return -1;
}

void DoCharacterKilledStatistics(int killerCharacterIdx,int deadCharacterIdx)
{
	ref killer = GetCharacter(killerCharacterIdx);
	ref dead = GetCharacter(deadCharacterIdx);

	string attrName = "" + Nations[sti(characters[deadCharacterIdx].nation)].Name;
	int oldValue = GetNationCharacterKilled(killer, sti(characters[deadCharacterIdx].nation));
	oldValue = oldValue + 1;
	killer.Statistics.KilledCharacter.Nation.(attrName) = oldValue;
	if (oldValue == (oldValue/5)*5)
	{
		ChangeCharacterFame(GetCharacter(killerCharacterIdx), 1);
	}
	if(characters[killerCharacterIdx].id == pchar.id && LAi_boarding_process == false)
	{
		if(CheckAttribute(&characters[deadCharacterIdx], "nation"))
		{
			if(sti(characters[deadCharacterIdx].nation) != PIRATE)
			{
				int iRepChange = 5 -  iGameArcade;
				ChangeCharacterReputation(pchar, -iRepChange, sti(characters[deadCharacterIdx].nation));
				if( LAi_grp_alarmactive ) {
					LAi_group_Attack(pchar, &characters[deadCharacterIdx]);
				}
			}
		}
	}

}

int GetNationCharacterKilled(ref _refCharacter,string nation)
{
	if( CheckAttribute(_refCharacter,"Statistics.KilledCharacter.Nation." + nation) )
		return sti(_refCharacter.Statistics.KilledCharacter.Nation.(nation));
	return 0;
}

string GetCrewBladeName(aref chr)
{
	string sBlade = "blade1";
	
	int iCrewExp = sti(chr.ship.crew.experience);
	
	if(iCrewExp < 100)
	{
		sBlade = "blade10";
	}

	if(iCrewExp < 75)
	{
		sBlade = "blade7";
	}

	if(iCrewExp < 50)
	{
		sBlade = "blade4";
	}

	if(iCrewExp < 25)
	{
		sBlade = "blade1";
	}

	return sBlade;
}
