
#include "scripts\colony.c"
#include "scripts\quest_capture_fort.c"
#include "scripts\flag.c"
#include "scripts\career.c"
#include "scripts\quest_defend_colony.c"
#include "scripts\quest_sink_ship.c"
#include "scripts\quest_kill_character.c"
#include "scripts\food.c"
#include "scripts\fame.c"
#include "scripts\quest_delivery_passenger.c"
#include "scripts\quest_delivery_trade.c"
#include "scripts\quest_steal_item.c"
#include "scripts\quest_delivery_item.c"
#include "scripts\free_adventure.c"
#include "scripts\time_events.c"
#include "scripts\quest_convoy.c"
#include "scripts\rumours.c"
#include "scripts\seaspeak.c"
#include "scripts\rangers.c"
#include "scripts\islandships.c"
#include "scripts\quest_disease.c"
#include "scripts\officers.c"
#include "scripts\sneaktotown.c"
#include "scripts\shipfame.c"
#include "scripts\historyevents.c"
#include "scripts\companions.c"
#include "scripts\ShipsUtilites.c"
#include "scripts\EuropeanTowns.c"
#include "scripts\ColonyUpgrades.c"
#include "scripts\Crew.c"
#include "scripts\bountyhunters.c"
#include "scripts\tavern.c"
#include "scripts\duel.c"
#include "scripts\quest_shablons.c"
#include "scripts\idioms.c"
#include "scripts\shipupgrades.c"
#include "scripts\dialogs.c"
#include "scripts\gold_convoy.c"
#include "scripts\slaves.c"
#include "scripts\tutorial.c"
#include "scripts\smuggling.c"

#define MAX_TOWNS	40

#define MAN 0
#define WOMAN 1

#define WITHOUT_SHIP 0
#define WITH_SHIP 1

#define WARRIOR 0
#define CITIZEN 1
#define TRADER 2
#define BOSS	3
#define FORT_COMMANDER	4
#define BOUNTY_HUNTER	5
#define SHAMAN	6
#define SOLDIER	7
#define OFFICER	8

#define QUEST_NOT_ACCEPTED	0
#define QUEST_ACCEPTED	1
#define QUEST_COMPLETED	2

object Towns[MAX_TOWNS];

#define MAX_CAREER_STEPS	12
object Career[MAX_CAREER_STEPS];


void TestFortAbordage(string sCharacter)
{
	int iChar = GenerateCharacter(ENGLAND, WITHOUT_SHIP, "citizen", MAN, 1, WARRIOR);
	AddPassenger(pchar, &characters[iChar], -1);
	LaunchFortCapture(CharacterFromID(sCharacter));
}

void TestShipAbordage()
{
	int iChar = GenerateCharacter(ENGLAND, WITH_SHIP, "citizen", MAN, 1, WARRIOR);
	LaunchRansackMain(pchar, &characters[iChar], "captain");
}

void SetNationRelations()
{
	int iRandEnemyQuantity;
	int iAgressionStateTemp;
	
	SetNationRelationBoth(ENGLAND, FRANCE, RELATION_FRIEND);
	SetNationRelationBoth(ENGLAND, SPAIN, RELATION_FRIEND);
	SetNationRelationBoth(ENGLAND, HOLLAND, RELATION_FRIEND);
	SetNationRelationBoth(ENGLAND, PIRATE, RELATION_ENEMY);

	SetNationRelationBoth(FRANCE, SPAIN, RELATION_FRIEND);
	SetNationRelationBoth(FRANCE, HOLLAND, RELATION_FRIEND);
	//SetNationRelationBoth(FRANCE, PIRATE, RELATION_FRIEND);

	SetNationRelationBoth(HOLLAND, SPAIN, RELATION_FRIEND);
	SetNationRelationBoth(HOLLAND, PIRATE, RELATION_ENEMY);

	SetNationRelationBoth(SPAIN, PIRATE, RELATION_ENEMY);
	
	// .  1  4
	int iConfictsNum = iAgressionState;
	int iNation, iEnemyNation;
	while(iConfictsNum > 0)
	{
		iNation = rand(PIRATE - 1);
		iEnemyNation = FindNonEnemyNation2NationWithoutPirates(iNation);
		if(GetNationRelation(iNation, iEnemyNation) != RELATION_ENEMY)
		{
			SetNationRelationBoth(iNation, iEnemyNation, RELATION_ENEMY);
			iConfictsNum--;
		}
	}
	
	string sNation;
	if(iRelationState == 1)
	{
		for(int k = 0; k < PIRATE; k++)
		{
			SetNationRelation2MainCharacter(k, RELATION_FRIEND);
		}
	}

	if(iRelationState == 2)
	{
		iConfictsNum = iRelationState;
		while(iConfictsNum > 0)
		{
			iNation = rand(PIRATE - 1);
			if(GetNationRelation2MainCharacter(iNation) != RELATION_ENEMY)
			{
				SetNationRelation2MainCharacter(iNation, RELATION_ENEMY);
				iConfictsNum--;
			}
		}
	}

	if(iRelationState == 3)
	{
		for(int m = 0; m < PIRATE; m++)
		{
			if(m != sti(pchar.nation))
			{
				SetNationRelation2MainCharacter(m, RELATION_ENEMY);
			}
		}
	}

	SetNationRelation2MainCharacter(PIRATE, RELATION_ENEMY);
}

void SetRelations(int iNation, int iRelation)
{
	SetNationRelation2MainCharacter(iNation, iRelation);
	pchar.quest.Relations.PeaceGroup = GetNationNameByType(iNation) + "_CITIZENS";
	LAi_group_SetRelation(pchar.quest.Relations.PeaceGroup, LAI_GROUP_PLAYER, iRelation);
	pchar.quest.Relations.PeaceGroup = GetNationNameByType(iNation) + "_SOLDIERS";
	LAi_group_SetRelation(pchar.quest.Relations.PeaceGroup, LAI_GROUP_PLAYER, iRelation);
}

int CalculateRelationSum(int iNation)
{
	string sNation = GetNationNameByType(iNation);
	int iSumm = sti(pchar.rank) * 100 + (100 - sti(Pchar.reputation.(sNation))) * 200;

	iSumm = iSumm * (1.0 - (0.1 * iGameArcade));

	Pchar.quest.Relations.sum = iSumm;
	
	return iSumm;
}

int FindFreeRandomOfficer()
{
	int Counter, OfficerIdx;
	bool officer = false;
	
	string OfficerId;

	for(counter = 0; counter <=9; counter++)
	{
		OfficerId = "Enc_Officer_0" + counter;
		OfficerIdx = GetCharacterIndex(OfficerId);
		for (int i=0; i<MAX_COLONIES; i++)
		{
			if (Colonies[i].commander == officerid)
			{
				officer = true;
			}
		}
		if(FindFellowTravellers(PChar, CharacterFromId(OfficerId)) == 0 && !officer) return OfficerIdx;
		officer = false;
	}

	return -1;
}

void CalculateShipForShipYard(aref chr)
{
	if(CheckAttribute(chr, "shipyard"))
	{
		return;
	}

	int iTest_ship;
	int iBeginPoint, iEndPoint;
	int iStep;
	int iNation
	string sStep;
	
	DeleteAttribute(chr, "shipyard");

	iTest_ship = rand(1);
	chr.shipyard.ship1 = SHIP_TARTANE;

	iStep = 2;
	iNation = chr.nation;
	
	string sLocation = pchar.location;
	sLocation = Locations[FindLocation(sLocation)].fastreload;
	
	int iShipYardLevel = sti(colonies[FindColony(sLocation)].shipyard);

	if (iShipYardLevel == 1)
	{
		iEndPoint = SHIP_CARAVEL;
	}

	if (iShipYardLevel == 2)
	{
		iEndPoint = SHIP_GALEON_L;
	}

	if (iShipYardLevel == 3)
	{
		iEndPoint = SHIP_PINNACE;
	}
	
	if (iShipYardLevel == 4)
	{
		iEndPoint = SHIP_FRIGATE;
	}

	//trace("isl"+ iEndPoint);
	
	int m = 2;
	for (int i = SHIP_LUGGER; i <= SHIP_FRIGATE; i++)
	{
		iTest_ship = GenerateShip(i, 1);
		sStep = "ship" + m;
		chr.shipyard.(sStep) = iTest_ship;
		if(i > iEndPoint)
		{
			chr.shipyard.(sStep).notforsale = 1;
		}
		m = m + 1;
	}

	string sQuest = "ShipyardCleanUpFor" + chr.id;
	if(!CheckAttribute(pchar, "quest." + sQuest))
	{
		int iDays = rand(5) + rand(5) + rand(5);
		pchar.quest.(sQuest).win_condition.l1 = "timer";
		pchar.quest.(sQuest).win_condition.l1.date.day = GetAddingDataDay(0, 0, idays);
		pchar.quest.(sQuest).win_condition.l1.date.month = GetAddingDataMonth(0, 0, idays);
		pchar.quest.(sQuest).win_condition.l1.date.year = GetAddingDataYear(0, 0, idays);
		pchar.quest.(sQuest).win_condition.l1.date.hour = rand(23);
		pchar.quest.(sQuest).win_condition = "ShipyardCleanUp";
		pchar.quest.(sQuest).function = "ShipyardCleanUp";
		pchar.quest.(sQuest).character = chr.id;
	}
}

void ShipyardCleanUp(string sQuest)
{
	string sChar = pchar.quest.(sQuest).character;
	string sStep;
	ref chr = characterFromID(sChar);
	int iShip, cn;
	bool isEraseShip;
	for(int i = 0; i < SHIP_TYPES_QUANTITY; i++)
	{
		sStep = "ship" + i;
		isEraseShip = true;
		if(CheckAttribute(chr, "shipyard." + sStep))
		{
			iShip = sti(chr.shipyard.(sStep));
			for(int k = 0; k < COMPANION_MAX; k++)
			{
				cn = GetCompanionIndex(pchar, k);
				{
					if(cn != -1)
					{
						if(iShip == sti(characters[cn].ship.type))
						{
							isEraseShip = false;
						}
					}
				}
			}
			if(isEraseShip == true)
			{
				EmptyOneFantomShip(iShip);
			}
		}
	}
	
	DeleteAttribute(chr, "shipyard");
}

bool CreateParticleSystemOnLocator(string _location_id, string _locatorName, string _particleName)
{
	aref locator;
	if (!FindLocator(_location_id, _locatorName, &locator, true))
		return false;

	CreateParticleSystemX(_particleName,stf(locator.x),stf(locator.y),stf(locator.z), stf(locator.vz.x),stf(locator.vz.y),stf(locator.vz.z),0);
	return true;
}

void GiveItemToTrader(aref ch)
{
	int irand;
	
	DeleteAttribute(ch, "items");
	
	TakeNItems(ch,"blade1", Rand(1)+1);
	TakeNItems(ch,"gun1", Rand(1)+1);

	int iChance = 0;

	float fLuck = GetSummonSkillFromName(pchar, SKILL_SNEAK);
	fLuck = fLuck * (1.0 + (0.5 * iGameArcade));
	for(int i = 0; i < ITEMS_QUANTITY, i++)
	{
		if(!CheckAttribute(&Items[i], "groupID")) 
		{
			continue;
		}
		if(Items[i].groupID == SABERGUN_ITEM_TYPE)
		{
			continue;
		}
		if(!CheckAttribute(&Items[i], "rare")) 
		{
			continue;
		}

		if(CheckAttribute(&Items[i], "uniq") && sti(items[i].uniq) != 0) 
		{
			continue;
		}
		if(items[i].groupID == BLADE_ITEM_TYPE || items[i].groupID == GUN_ITEM_TYPE || items[i].groupID == SPYGLASS_ITEM_TYPE)
		{
			if(stf(items[i].rare) < 10.0)
			{
				continue;
			}
			if(CheckAttribute(&items[i], "minlevel"))
			{
				if(sti(items[i].minlevel) > sti(pchar.rank) + 3)
				{
					continue;
				}
			}
			iChance = rand(100); //  . 2         .
			if(stf(items[i].rare) + fLuck >= iChance)
			{
				TakeNItems(ch, items[i].id, 1);
			}
		}
	}
}

void PlaceCharacter(aref ch, string group, string stype)
{
	float locx;
	float locy;
	float locz;
	string homelocator;
	
	GetCharacterPos(pchar, &locx, &locy, &locz);
	if (sType == "random")
	{
		homelocator = LAi_FindFreeRandomLocator(group);
	}
	else
	{
		homelocator = LAi_FindNearestFreeLocator(group, locx, locy, locz);
	}
	ChangeCharacterAddressGroup(ch, pchar.location, group, homelocator);
}

void SetRelationsInNewGame()
{			
	LAi_group_SetAlarmReaction("HOLLAND_SOLDIERS", LAI_GROUP_PLAYER, LAI_GROUP_ENEMY, LAI_GROUP_FRIEND);
	LAi_group_SetRelation("HOLLAND_CITIZENS", "HOLLAND_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("HOLLAND_SOLDIERS", "HOLLAND_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("HOLLAND_SOLDIERS", "HOLLAND_CITIZENS", LAI_GROUP_FRIEND);
	LAi_group_SetAlarmReaction("HOLLAND_SOLDIERS", "HOLLAND_CITIZENS", LAI_GROUP_FRIEND, LAI_GROUP_FRIEND);
	LAi_group_SetAlarmReaction("HOLLAND_CITIZENS", "HOLLAND_SOLDIERS", LAI_GROUP_FRIEND, LAI_GROUP_FRIEND);
	LAi_group_SetRelation("HOLLAND_SOLDIERS", LAI_DEFAULT_GROUP, LAI_GROUP_FRIEND);
	LAi_group_SetLookRadius("HOLLAND_SOLDIERS", LAI_GROUP_GRD_LOOK);
	LAi_group_SetHearRadius("HOLLAND_SOLDIERS", LAI_GROUP_GRD_HEAR);
	LAi_group_SetSayRadius("HOLLAND_SOLDIERS", LAI_GROUP_GRD_SAY);
	LAi_group_SetPriority("HOLLAND_CITIZENS", LAI_GROUP_PCITIZENS);
	LAi_group_SetPriority("HOLLAND_SOLDIERS", LAI_GROUP_PGUARDS);

	LAi_group_SetLookRadius("HOLLAND_SOLDIERS", LAI_GROUP_DEF_LOOK);
	LAi_group_SetHearRadius("HOLLAND_SOLDIERS", LAI_GROUP_DEF_HEAR);
	LAi_group_SetSayRadius("HOLLAND_SOLDIERS", LAI_GROUP_DEF_SAY);

	LAi_group_SetAlarmReaction("FRANCE_SOLDIERS", LAI_GROUP_PLAYER, LAI_GROUP_ENEMY, LAI_GROUP_FRIEND);
	LAi_group_SetRelation("FRANCE_CITIZENS", "FRANCE_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("FRANCE_SOLDIERS", "FRANCE_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("FRANCE_SOLDIERS", "FRANCE_CITIZENS", LAI_GROUP_FRIEND);
	LAi_group_SetAlarmReaction("FRANCE_SOLDIERS", "FRANCE_CITIZENS", LAI_GROUP_FRIEND, LAI_GROUP_FRIEND);
	LAi_group_SetAlarmReaction("FRANCE_CITIZENS", "FRANCE_SOLDIERS", LAI_GROUP_FRIEND, LAI_GROUP_FRIEND);
	LAi_group_SetRelation("FRANCE_SOLDIERS", LAI_DEFAULT_GROUP, LAI_GROUP_FRIEND);
	LAi_group_SetLookRadius("FRANCE_SOLDIERS", LAI_GROUP_GRD_LOOK);
	LAi_group_SetHearRadius("FRANCE_SOLDIERS", LAI_GROUP_GRD_HEAR);
	LAi_group_SetSayRadius("FRANCE_SOLDIERS", LAI_GROUP_GRD_SAY);
	LAi_group_SetPriority("FRANCE_CITIZENS", LAI_GROUP_PCITIZENS);
	LAi_group_SetPriority("FRANCE_SOLDIERS", LAI_GROUP_PGUARDS);

	LAi_group_SetLookRadius("FRANCE_CITIZENS", LAI_GROUP_DEF_LOOK);
	LAi_group_SetHearRadius("FRANCE_CITIZENS", LAI_GROUP_DEF_HEAR);
	LAi_group_SetSayRadius("FRANCE_CITIZENS", LAI_GROUP_DEF_SAY);

	LAi_group_SetAlarmReaction("SPAIN_SOLDIERS", LAI_GROUP_PLAYER, LAI_GROUP_ENEMY, LAI_GROUP_FRIEND);
	LAi_group_SetRelation("SPAIN_CITIZENS", "SPAIN_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("SPAIN_SOLDIERS", "SPAIN_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("SPAIN_SOLDIERS", "SPAIN_CITIZENS", LAI_GROUP_FRIEND);
	LAi_group_SetAlarmReaction("SPAIN_SOLDIERS", "SPAIN_CITIZENS", LAI_GROUP_FRIEND, LAI_GROUP_FRIEND);
	LAi_group_SetAlarmReaction("SPAIN_CITIZENS", "SPAIN_SOLDIERS", LAI_GROUP_FRIEND, LAI_GROUP_FRIEND);
	LAi_group_SetRelation("SPAIN_SOLDIERS", LAI_DEFAULT_GROUP, LAI_GROUP_FRIEND);
	LAi_group_SetLookRadius("SPAIN_SOLDIERS", LAI_GROUP_GRD_LOOK);
	LAi_group_SetHearRadius("SPAIN_SOLDIERS", LAI_GROUP_GRD_HEAR);
	LAi_group_SetSayRadius("SPAIN_SOLDIERS", LAI_GROUP_GRD_SAY);
	LAi_group_SetPriority("SPAIN_CITIZENS", LAI_GROUP_PCITIZENS);
	LAi_group_SetPriority("SPAIN_SOLDIERS", LAI_GROUP_PGUARDS);

	LAi_group_SetLookRadius("SPAIN_CITIZENS", LAI_GROUP_DEF_LOOK);
	LAi_group_SetHearRadius("SPAIN_CITIZENS", LAI_GROUP_DEF_HEAR);
	LAi_group_SetSayRadius("SPAIN_CITIZENS", LAI_GROUP_DEF_SAY);

	LAi_group_SetAlarmReaction("ENGLAND_SOLDIERS", LAI_GROUP_PLAYER, LAI_GROUP_ENEMY, LAI_GROUP_FRIEND);
	LAi_group_SetRelation("ENGLAND_CITIZENS", "ENGLAND_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("ENGLAND_SOLDIERS", "ENGLAND_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("ENGLAND_SOLDIERS", "ENGLAND_CITIZENS", LAI_GROUP_FRIEND);
	LAi_group_SetAlarmReaction("ENGLAND_SOLDIERS", "ENGLAND_CITIZENS", LAI_GROUP_FRIEND, LAI_GROUP_FRIEND);
	LAi_group_SetAlarmReaction("ENGLAND_CITIZENS", "ENGLAND_SOLDIERS", LAI_GROUP_FRIEND, LAI_GROUP_FRIEND);
	LAi_group_SetRelation("ENGLAND_SOLDIERS", LAI_DEFAULT_GROUP, LAI_GROUP_FRIEND);
	LAi_group_SetLookRadius("ENGLAND_SOLDIERS", LAI_GROUP_GRD_LOOK);
	LAi_group_SetHearRadius("ENGLAND_SOLDIERS", LAI_GROUP_GRD_HEAR);
	LAi_group_SetSayRadius("ENGLAND_SOLDIERS", LAI_GROUP_GRD_SAY);
	LAi_group_SetPriority("ENGLAND_CITIZENS", LAI_GROUP_PCITIZENS);
	LAi_group_SetPriority("ENGLAND_SOLDIERS", LAI_GROUP_PGUARDS);

	LAi_group_SetLookRadius("ENGLAND_CITIZENS", LAI_GROUP_DEF_LOOK);
	LAi_group_SetHearRadius("ENGLAND_CITIZENS", LAI_GROUP_DEF_HEAR);
	LAi_group_SetSayRadius("ENGLAND_CITIZENS", LAI_GROUP_DEF_SAY);

	LAi_group_SetAlarmReaction("PIRATE_CITIZENS", LAI_GROUP_PLAYER, LAI_GROUP_ENEMY, LAI_GROUP_FRIEND);
	LAi_group_SetRelation("PIRATE_CITIZENS", "PIRATE_CITIZENS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("PIRATE_CITIZENS", LAI_DEFAULT_GROUP, LAI_GROUP_FRIEND);
	LAi_group_SetLookRadius("PIRATE_CITIZENS", LAI_GROUP_GRD_LOOK);
	LAi_group_SetHearRadius("PIRATE_CITIZENS", LAI_GROUP_GRD_HEAR);
	LAi_group_SetSayRadius("PIRATE_CITIZENS", LAI_GROUP_GRD_SAY);
	LAi_group_SetPriority("PIRATE_CITIZENS", LAI_GROUP_PCITIZENS);
	LAi_group_SetPriority("PIRATE_CITIZENS", LAI_GROUP_PGUARDS);

	LAi_group_Register("FULLY_ALIIES_TO_US");
	LAi_group_SetAlarmReaction("FULLY_ALIIES_TO_US", LAI_GROUP_PLAYER, LAI_GROUP_FRIEND, LAI_GROUP_FRIEND);
	LAi_group_SetRelation("FULLY_ALIIES_TO_US", LAI_GROUP_PLAYER, LAI_GROUP_FRIEND);
	
	SetNationRelations();

	SetNationState();

	pchar.money = sti(pchar.money) * iGameArcade;


	//iWithoutShip = GenerateShip(SHIP_WAR_TARTANE, 1);
}

void PrepareVisitIsland()
{
	
	string sQuest;
	for (int i=0; i<MAX_COLONIES; i++)
	{
		sQuest = "VisitColony_" + Colonies[i].id;
		pchar.quest.(sQuest).win_condition.l1 = "location";
		pchar.quest.(sQuest).win_condition.l1.location = Colonies[i].id + "_port";
		pchar.quest.(sQuest).win_condition = "VisitIsland";
		pchar.quest.(sQuest).colony = Colonies[i].id;
	}
}

void IslandVisited(string sQuest)
{
	
	string sColony = pchar.quest.(sQuest).colony;
	Colonies[FindColony(sColony)].visited = "1";
}

int CheckSkillDownModifier(aref chr, int iship)
{
	if (iship < 1000)
	{
		ref refShip = GetRealShip(iship));
		
		int ShipClass = refShip.Class;
		
		int iMultiplier = 0;
		
		object ShipClassPossible[11];
		
		ShipClassPossible[0].rank = 1;
		ShipClassPossible[0].shipclass = 6;
		
		ShipClassPossible[1].rank = 2;
		ShipClassPossible[1].shipclass = 6;
		
		ShipClassPossible[2].rank = 3;
		ShipClassPossible[2].shipclass = 5;
		
		ShipClassPossible[3].rank = 4;
		ShipClassPossible[3].shipclass = 5;
		
		ShipClassPossible[4].rank = 5;
		ShipClassPossible[4].shipclass = 4;
		
		ShipClassPossible[5].rank = 6;
		ShipClassPossible[5].shipclass = 4;
		
		ShipClassPossible[6].rank = 7;
		ShipClassPossible[6].shipclass = 3;
		
		ShipClassPossible[7].rank = 8;
		ShipClassPossible[7].shipclass = 3;
		
		ShipClassPossible[8].rank = 9;
		ShipClassPossible[8].shipclass = 2;
		
		ShipClassPossible[9].rank = 10;
		ShipClassPossible[9].shipclass = 2;
		
		ShipClassPossible[10].rank = 11;
		ShipClassPossible[10].shipclass = 1;
		
		for (int i =0; i < 11; i ++)
		{
			if (sti(chr.rank) == sti(ShipClassPossible[i].rank))
			{
				if(ShipClass < sti(ShipClassPossible[i].shipclass))
				{
					iMultiplier = sti(ShipClassPossible[i].shipclass) - ShipClass;
				}
			}
		}
		
		return iMultiplier;
	}
	return 0;
}


int SearchForMaxShip(aref chr, int isLock, int iType)
{
	object ShipClassPossible[11];

	ShipClassPossible[0].rank = 1;
	ShipClassPossible[0].shipclass = 6;
	
	ShipClassPossible[1].rank = 2;
	ShipClassPossible[1].shipclass = 6;
	
	ShipClassPossible[2].rank = 3;
	ShipClassPossible[2].shipclass = 5;
	
	ShipClassPossible[3].rank = 4;
	ShipClassPossible[3].shipclass = 5;
	
	ShipClassPossible[4].rank = 5;
	ShipClassPossible[4].shipclass = 4;
	
	ShipClassPossible[5].rank = 6;
	ShipClassPossible[5].shipclass = 4;
	
	ShipClassPossible[6].rank = 7;
	ShipClassPossible[6].shipclass = 3;
	
	ShipClassPossible[7].rank = 8;
	ShipClassPossible[7].shipclass = 3;
	
	ShipClassPossible[8].rank = 9;
	ShipClassPossible[8].shipclass = 2;
	
	ShipClassPossible[9].rank = 10;
	ShipClassPossible[9].shipclass = 2;
	
	ShipClassPossible[10].rank = 11;
	ShipClassPossible[10].shipclass = 1;

	int iRank = sti(chr.rank);

	int iShipClass = 6;
	for(int i = 0; i<11; i++)
	{
		if (iRank >= sti(ShipClassPossible[i].rank))
		{
			iShipClass = sti(ShipClassPossible[i].shipclass);
		}
	}

	int iShipQuantity = 0;
	for(i = SHIP_LUGGER; i<SHIP_TYPES_QUANTITY; i++)
	{
		if(iShipClass <= sti(ShipsTypes[i].Class))
		{
			iShipQuantity++;
		}
	}
	iShipQuantity = iShipQuantity/2;
	iShipQuantity = rand(iShipQuantity) + rand(iShipQuantity);
	if(iShipQuantity < SHIP_LUGGER)
	{
		iShipQuantity = SHIP_LUGGER;
	}
	if(iShipQuantity >= SHIP_TYPES_QUANTITY)
	{
		iShipQuantity = SHIP_TYPES_QUANTITY - 1;
	}

	if(iType == BOSS && iShipQuantity < SHIP_CORVETTE)
	{
		iShipQuantity = rand(7) + 10;//   
	}
	iShipQuantity = GenerateShip(iShipQuantity, isLock);
	return iShipQuantity;
}

void CheckShipRank(aref Character)
{
	if (sti(Character.ship.type) < 1000 && sti(Character.ship.type) != SHIP_NOTUSED)
	{
		ref refShip = GetRealShip(sti(Character.ship.type));
		
		int ShipClass = refShip.Class;
		
		int iMultiplier = 0;
		
		object ShipClassPossible[11];
		
		ShipClassPossible[0].rank = 1;
		ShipClassPossible[0].shipclass = 6;
		
		ShipClassPossible[1].rank = 2;
		ShipClassPossible[1].shipclass = 6;
		
		ShipClassPossible[2].rank = 3;
		ShipClassPossible[2].shipclass = 5;
		
		ShipClassPossible[3].rank = 4;
		ShipClassPossible[3].shipclass = 5;
		
		ShipClassPossible[4].rank = 5;
		ShipClassPossible[4].shipclass = 4;
		
		ShipClassPossible[5].rank = 6;
		ShipClassPossible[5].shipclass = 4;
		
		ShipClassPossible[6].rank = 7;
		ShipClassPossible[6].shipclass = 3;
		
		ShipClassPossible[7].rank = 8;
		ShipClassPossible[7].shipclass = 3;
		
		ShipClassPossible[8].rank = 9;
		ShipClassPossible[8].shipclass = 2;
		
		ShipClassPossible[9].rank = 10;
		ShipClassPossible[9].shipclass = 2;
		
		ShipClassPossible[10].rank = 11;
		ShipClassPossible[10].shipclass = 1;
		
		for (int i =0; i < 11; i ++)
		{
			if (sti(Character.rank) == sti(ShipClassPossible[i].rank))
			{
				if(ShipClass < sti(ShipClassPossible[i].shipclass))
				{
					iMultiplier = sti(ShipClassPossible[i].shipclass) - ShipClass;
				}
			}
		}
		Character.skill.sailing = sti(Character.skill.temp.sailing) - iMultiplier;
		Character.skill.tactic = sti(Character.skill.temp.tactic) - iMultiplier;
		Character.skill.accuracy = sti(Character.skill.temp.accuracy) - iMultiplier;
		Character.skill.cannons = sti(Character.skill.temp.cannons) - iMultiplier;
		Character.skill.grappling = sti(Character.skill.temp.grappling) - iMultiplier;
		Character.skill.repair = sti(Character.skill.temp.repair) - iMultiplier;
		Character.skill.defence = sti(Character.skill.temp.defence) - iMultiplier;
	}
}

string SearchFormaxShipClass(aref chr)
{
	object ShipClassPossible[11];
		
	ShipClassPossible[0].rank = 1;
	ShipClassPossible[0].shipclass = 6;
	
	ShipClassPossible[1].rank = 2;
	ShipClassPossible[1].shipclass = 6;
	
	ShipClassPossible[2].rank = 3;
	ShipClassPossible[2].shipclass = 5;
	
	ShipClassPossible[3].rank = 4;
	ShipClassPossible[3].shipclass = 5;
	
	ShipClassPossible[4].rank = 5;
	ShipClassPossible[4].shipclass = 4;
	
	ShipClassPossible[5].rank = 6;
	ShipClassPossible[5].shipclass = 4;
	
	ShipClassPossible[6].rank = 7;
	ShipClassPossible[6].shipclass = 3;
	
	ShipClassPossible[7].rank = 8;
	ShipClassPossible[7].shipclass = 3;
	
	ShipClassPossible[8].rank = 9;
	ShipClassPossible[8].shipclass = 2;
	
	ShipClassPossible[9].rank = 10;
	ShipClassPossible[9].shipclass = 2;
	
	ShipClassPossible[10].rank = 11;
	ShipClassPossible[10].shipclass = 1;
	
	for(int i = 0; i<11; i++)
	{
		if (sti(chr.rank) == sti(ShipClassPossible[i].rank))
		{
			return ShipClassPossible[i].shipclass;
		}
	}
	
	return "1";
}

int CreatePrisoner(aref chr)
{
	int iChar = FindFirstEmptyCharacter();
	CopyAttributes(&characters[iChar], chr);
	characters[iChar].ship.type = SHIP_NOTUSED;
	characters[iChar].fantom = 1;
	characters[iChar].characterlock = 1;
	characters[iChar].index = iChar;
	chr.id = 0;
	
	return iChar;
}


void ReleasePrisoner(aref chr)
{
	int index = chr.index;
	if (index >=GetCharacterIndex("Ranger 0") && index < GetCharacterIndex("Ranger 0")+iRangersRate)
	{
		GenerateRumour("ranger_uncaptured", index, FindIsland(characters[index].adventure.endColony), sti(characters[index].type));
		characters[index].colony = characters[index].adventure.endColony;
	
		SetBaseShipData(&characters[index]);
		RechargeRangerAdventure(&characters[index]);
		return;
	}
	else
	{
		DeleteAttribute(chr, "characterlock");
	}
	
}

bool CheckForBountyCharacters(int iNation)
{
	

	int iPassQuantity = GetPassengersQuantity(pchar);
	int cn = -1;

	string sNation = GetNationNameByType(iNation);

	for(int i = 0; i < iPassQuantity; i++)
	{
		cn = GetPassenger(pchar, i);
		if(CheckAttribute(&characters[cn], "prisoner"))
		{
			if(sti(characters[cn].prisoner) == 1)
			{
				if(CheckAttribute(&characters[cn], "bounty."+sNation+".money"))
				{
					if(sti(characters[cn].bounty.(sNation).money) > 0)
					{
						return true;
					}
				}
			}
		}
	}

	return false;
}


void ReleaseBounty(int iNation)
{
	

	int iPassQuantity = GetPassengersQuantity(pchar);
	int cn = -1;
	int iMoney = 0;

	string sNation = GetNationNameByType(iNation);

	for(int i = 0; i < iPassQuantity; i++)
	{
		cn = GetPassenger(pchar, i);
		if(sti(characters[cn].prisoner) == 1)
		{
			if(CheckAttribute(&characters[cn], "bounty."+sNation+".money"))
			{
				if(sti(characters[cn].bounty.(sNation).money) > 0)
				{
					iMoney = iMoney + sti(characters[cn].bounty.(sNation).money);
					RemovePassenger(pchar, &characters[cn]);
					characters[cn].prisoned = 0;
					DeleteAttribute(&characters[cn], "characterlock");
				}
			}
		}
	}

	//         .
}

int FindFirstEmptyCharacter()
{
	for(int i = globalCharacters; i<MAX_CHARACTERS; i++)
	{
		if (characters[i].id == "0")
		{
			return i;
		}
	}
	
	return -1;
}

int CheckForMonthConsuption(aref chr)
{
	int iSumm = CheckForCrewMonthConsuption(chr) + CheckForOfficersMonthConsuption(chr);
	if(iSumm < 0)
	{
		iSumm = 0;
	}
	return iSumm;
}

int CheckForCrewMonthConsuption(aref chr)
{
	int nPaymentQ = sti(chr.month.money)*sti(chr.paymenttype)/100;	

	return nPaymentQ;
}

int CheckForOfficersMonthConsuption(aref chr)
{
	int nPaymentO = 0;
	int off = -1;


	for (int i = 0; i<GetPassengersQuantity(chr); i++)
	{
		off = GetPassenger(chr,i);
		if (off != -1)
		{
			if (checkattribute(&characters[off], "quest.OfficerPrice"))
			{
				if(sti(characters[off].prisoned) != 1)
				{
					nPaymentO = nPaymentO + sti(characters[off].quest.OfficerPrice);
				}
			}
		}
	}

	return nPaymentO;
}

void AddGeometryToLocation(string LocationID, string ModelName)
{
	ref LocationRef;
	int n = 1;
	string str;
	locationRef = &locations[FindLocation(LocationID)];

	for(n = 1; n < 10; n++)
	{
		str = n;
		if(!CheckAttribute(LocationRef, "models.always." + str))
		{
			LocationRef.models.always.(str) = ModelName;
			LocationRef.models.always.(str).tech = "dLightModel";
			break;
		}
	}
}	

void RemoveGeometryFromLocation(string LocationID, string ModelName)
{
	ref LocationRef;
	int n = 1;
	string str;
	//trace("FUNCTION RemoveGeometryFromLocation reports: Current location ID is " + LocationID + " and geometry " + ModelName + " should be removed");
	if(FindLocation(LocationID) != -1)
	{
		locationRef = &locations[FindLocation(LocationID)];
	}
	else
	{
		return;
	}

	for(n = 1; n < 10; n++)
	{
		str = n;
		//trace("FUNCTION RemoveGeometryFromLocation reports: Checking Geometry name for n = " + str + ". It is " + LocationRef.models.always.(str));
		if(LocationRef.models.always.(str) == ModelName)
		{
			//trace("JOPA!");
			DeleteAttribute(LocationRef, "models.always." + str);
			break;
		}
	}
}	


void CreateModel(int iChar, string sType, int iSex)
{
	int iNation = sti(characters[iChar].nation);
	
	string sBody = "";
	string sPrefix = "";
	int iNumber = -1;
		
	switch (sType)
	{
		case "pofficer":
			sBody = "officer";
			iNumber = rand(11)+1;
		break;

		case "officer":
			sBody = "off";
			iNumber = rand(1)+1;
		break;
		
		case "soldier":
			sBody = "sold";
			iNumber = rand(7)+1;
		break;
		
		case "pirate":
			sBody = "pirate";
			iNumber = rand(9)+1;
		break;

		case "trader":
			sBody = "trader";
			iNumber = rand(15)+1;
		break;
		
		case "citizen":
			if(iSex == MAN)
			{
				sBody = "citiz";
				iNumber = rand(11)+1;
			}
			else
			{
				sBody = "girl";
				iNumber = rand(3)+1;
			}
		break;

		case "whore":
			sBody = "whore";
			iNumber = rand(3) + 1;
		break;
	}

	sPrefix = "_";
	
	if(sType == "officer" || sType == "soldier")
	{
		switch (iNation)
		{
			case ENGLAND:
				sPrefix = "_eng_";
			break;
			
			case FRANCE:
				sPrefix = "_fra_";
			break;
			
			case SPAIN:
				sPrefix = "_spa_";
			break;
			
			case HOLLAND:
				sPrefix = "_hol_";
			break;
			
			case PIRATE:
				sPrefix = "";
			break;
		}
	}
	
	string sResult = "";
	
	sResult = sBody+sPrefix+iNumber;
	
	characters[iChar].model = sResult;

	FaceMaker(&characters[iChar]);
}

string FindNonEnemyColonyForAdventure(int iNation, string sBeginColony)
{
	string sColony = "";
	
	int iArray[MAX_COLONIES-1];
	int m = 0;
	
	for (int i=0; i<MAX_COLONIES; i++)
	{
		if (colonies[i].nation != "none")
		{
			if (GetNationRelation(sti(Colonies[i].nation), iNation) != RELATION_ENEMY && Colonies[i].id != sBeginColony && colonies[i].nation != "none")
			{
				iArray[m] = i;
				m++;
			}
		}
	}
	
	if (m == 0)
	{
		return "-1";
	}
	
	m = rand(m-1);
	m = iArray[m];
	sColony = Colonies[m].id;
	
	return sColony;
}

string FindNonEnemyColonyForNation(int iNation)
{
	int iArray[MAX_COLONIES];
	int m = 0;
	string sColony = "";
	
	for (int i = 0; i<MAX_COLONIES; i++)
	{
		if(colonies[i].nation != "none")
		{
			if (GetNationRelation(sti(Colonies[i].nation), iNation) != RELATION_ENEMY)
			{
				iArray[m] = i;
				m++;
			}
		}
	}
	
	if (m == 0)
	{
		return "-1";
	}
	
	m = rand(m-1);
	m = iArray[m];
	sColony =  Colonies[m].id;
	
	return sColony;
}

string FindEnemyColonyForNation(int iNation)
{
	int iArray[MAX_COLONIES];
	int m = 0;
	string sColony = "-1";
	int iColonyNation = -1;
	
	for (int i = 0; i<MAX_COLONIES; i++)
	{
		if(colonies[i].nation != "none" || colonies[i].id == "IslaMona")
		{
			if(colonies[i].id == "IslaMona")
			{
				iColonyNation = PIRATE;
			}
			else
			{
				iColonyNation = sti(Colonies[i].nation);
			}
			if (GetNationRelation(iColonyNation, iNation) == RELATION_ENEMY)
			{
				iArray[m] = i;
				m++;
			}
		}
	}
	
	if (m == 0)
	{
		return "-1";
	}
	
	m = rand(m - 1);
	m = iArray[m];
	sColony =  Colonies[m].id;
	
	return sColony;
}

string FindEnemyColonyForNationExceptPirates(int iNation)
{
	int iArray[MAX_COLONIES];
	int m = 0;
	string sColony = "-1";
	int iColonyNation = -1;
	
	for (int i = 0; i<MAX_COLONIES; i++)
	{
		if(colonies[i].nation != "none")
		{
			iColonyNation = sti(Colonies[i].nation);
			if (GetNationRelation(iColonyNation, iNation) == RELATION_ENEMY)
			{
				iArray[m] = i;
				m++;
			}
		}
	}
	
	if (m == 0)
	{
		return "-1";
	}
	
	m = rand(m - 1);
	m = iArray[m];
	sColony =  Colonies[m].id;
	
	return sColony;
}

string FindNonEnemyColonyForNationExceptColony(string sHomeColony)
{
	int iArray[MAX_COLONIES];
	int m = 0;
	string sColony = "-1";

	int iNation = sti(colonies[FindColony(sHomeColony)].nation);
	
	for (int i = 0; i<MAX_COLONIES; i++)
	{
		if(colonies[i].nation != "none" && colonies[i].id != sHomeColony)
		{
			if (GetNationRelation(sti(Colonies[i].nation), iNation) != RELATION_ENEMY)
			{
				iArray[m] = i;
				m++;
			}
		}
	}
	
	if (m == 0)
	{
		return "-1";
	}
	
	m = rand(m-1);
	m = iArray[m];
	sColony =  Colonies[m].id;
	
	return sColony;
}

string FindNonEnemyColonyForNationExceptColonyAndNation(string sHomeColony, int iCheckNation)
{
	int iArray[MAX_COLONIES];
	int m = 0;
	string sColony = "-1";

	int iNation = sti(colonies[FindColony(sHomeColony)].nation);
	
	for (int i = 0; i<MAX_COLONIES; i++)
	{
		if(colonies[i].nation != "none" && colonies[i].id != sHomeColony && sti(colonies[i].nation) != iCheckNation)
		{
			if (GetNationRelation(sti(Colonies[i].nation), iNation) != RELATION_ENEMY)
			{
				iArray[m] = i;
				m++;
			}
		}
	}
	
	if (m == 0)
	{
		return "-1";
	}
	
	m = rand(m-1);
	m = iArray[m];
	sColony =  Colonies[m].id;
	
	return sColony;
}

string FindRandomColonyExceptColony(string sHomeColony)
{
	int iArray[MAX_COLONIES];
	int m = 0;
	string sColony = "";

	int iNation = sti(colonies[FindColony(sHomeColony)].nation);
	
	for (int i = 0; i<MAX_COLONIES; i++)
	{
		if(colonies[i].nation != "none" && colonies[i].id != sHomeColony)
		{
			iArray[m] = i;
			m++;
		}
	}
	
	if (m == 0)
	{
		return "-1";
	}
	
	m = rand(m-1);
	m = iArray[m];
	sColony =  Colonies[m].id;
	
	return sColony;
}

string FindAlliedColonyForNation(int iNation)
{
	int iArray[MAX_COLONIES];
	int m = 0;
	string sColony = "";
	
	for (int i = 0; i<MAX_COLONIES; i++)
	{
		if(colonies[i].nation != "none")
		{
			if (sti(Colonies[i].nation)== iNation)
			{
				iArray[m] = i;
				m++;
			}
		}
	}
	
	if (m == 0)
	{
		return "-1";
	}
	
	m = rand(m-1);
	m = iArray[m];
	sColony =  Colonies[m].id;
	
	return sColony;
}

string FindAlliedColonyForNationExceptColony(string sHomeColony)
{
	int iArray[MAX_COLONIES];
	int m = 0;
	string sColony = "";

	int iNation = sti(colonies[FindColony(sHomeColony)].nation);
	
	for (int i = 0; i<MAX_COLONIES; i++)
	{
		if(colonies[i].nation != "none" && colonies[i].id != sHomeColony)
		{
			if (sti(Colonies[i].nation) == iNation)
			{
				iArray[m] = i;
				m++;
			}
		}
	}
	
	if (m == 0)
	{
		return "-1";
	}
	
	m = rand(m-1);
	m = iArray[m];
	sColony =  Colonies[m].id;
	
	return sColony;
}

void EmptyAllFantomCharacter()
{
	int cn = -1;
	for (int i=globalCharacters; i<MAX_CHARACTERS; i++)
	{
		if (CheckAttribute(&characters[i], "fantom") && !CheckAttribute(&characters[i], "characterlock"))
		{
			if(GetCompanionQuantity(&characters[i]) > 1)
			{
				for(int k = 0; k < COMPANION_MAX; k++)
				{
					cn = GetCompanionIndex(&characters[i], k);
					if(cn != -1)
					{
						RemoveCharacterCompanion(&characters[i], &characters[cn]);
						DeleteAttribute(&characters[cn], "characterlock");
						EmptyFantomCharacacter(&characters[cn]);
					}
				}
			}
			else
			{
				EmptyFantomCharacacter(&characters[i]);
			}
		}
	}
}


void EmptyFantomCharacacter(aref chr)
{
	int i = sti(chr.index);
	if (!CheckAttribute(chr, "characterlock"))
	{
		LAi_LockFightMode(chr, false);
		LAi_CharacterEnableDialog(chr);
		chr.id = "0";
		DeleteAttribute(chr, "fantom");
		DeleteAttribute(chr, "isquest");
		DeleteAttribute(chr, "isvip");
		DeleteAttribute(chr, "isprisonquest");
		DeleteAttribute(chr, "isofficer");
		DeleteAttribute(chr, "quest");
		DeleteAttribute(chr, "loyality");
		DeleteAttribute(chr, "abordage_twice");
		chr.prisoned = 0;
		chr.money = 0;
		DeleteAttribute(chr, "employer");
		LAi_NPC_Equip(chr, 1, false, false);
		chr.location = "none";
		DeleteAttribute(chr, "fantom");
		DeleteAttribute(chr, "relation");
		DeleteAttribute(chr, "cannotsurrender");
		DeleteAttribute(chr, "ship.upper_model");
		DeleteAttribute(chr, "items");
		DeleteAttribute(chr, "equip");
		DeleteAttribute(chr, "quest.questflag");
		DeleteAttribute(chr, "quest");
		DeleteAttribute(chr, "relation");
		DeleteAttribute(chr, "location.loadcapture");
		DeleteAttribute(chr, "CurrentQuest");
		DeleteAttribute(chr, "tutorial");
		DeleteAttribute(chr, "seaai");
		DeleteAttribute(chr, "booty");
		DeleteAttribute(chr, "ShipCapture");
		DeleteAttribute(chr, "speak");
		DeleteAttribute(chr, "relation.UseOtherCharacter");
		DeleteAttribute(chr, "issmuggler");
		DeleteAttribute(chr, "last_speak");
		DeleteAttribute(chr, "reputation_influense");
		LAi_SetImmortal(chr, 0);
		int iShip = sti(chr.ship.type);
		EmptyOneFantomShip(iShip);
	}
}

string SelectQuestDestinationAnyNationExceptTargetNation(int iNation)
{	
	string sArray[MAX_COLONIES];
	int m = 0;
	
	for (int i = 0; i<MAX_COLONIES; i++)
	{
		if (sti(Colonies[i].nation) != iNation)
		{
			sArray[m] = Colonies[i].id;
			m++;
		}
	}
	
	if (m > 0)
	{
		m = rand(m-1);
		return sArray[m];
	}
	else
	{
		return "Error in select Destination for capture ship";
	}
}

string SelectQuestDestinationAnyNationExceptIsland(string sIsland)
{
	int m = 0;
	
	string sTempIsland = sIsland;

	while(sTempIsland == sisland)
	{
		m = rand(MAX_COLONIES-1);
		if(colonies[m].nation != "none")
		{
			sTempIsland = Colonies[m].island;
		}
	}
	string sTempColony  = Colonies[m].id
	return sTempColony;
}

string SelectQuestDestinationAnyNationExceptColony(string sColony)
{
	int m;
	
	string sTempColony = sColony;

	while(sTempColony == sColony)
	{
		m = rand(MAX_COLONIES-1);
		if(colonies[m].nation != "none")
		{
			sTempColony = Colonies[m].id;
		}
	}
	
	return sTempColony;
}

int GenerateCharacter(int iNation, int isShip, string sModel, int iSex, int isLock, int CharacterType)
{
	int iChar = FindFirstEmptyCharacter();

	EmptyFantomCharacacter(&characters[iChar]);
	if(!CheckAttribute(&characters[iChar], "lifetime"))
	{
		characters[iChar].lifetime = 0;
	}
	characters[iChar].lifetime = (sti(characters[iChar].lifetime) + 1);

	characters[iChar].skill.Leadership = 1;
	characters[iChar].skill.Fencing = 1;
	characters[iChar].skill.Gun = 1;
	characters[iChar].skill.Sailing = 1;
	characters[iChar].skill.Accuracy = 1;
	characters[iChar].skill.Cannons = 1;
	characters[iChar].skill.Grappling = 1;
	characters[iChar].skill.Repair = 1;
	characters[iChar].skill.Defence = 1;
	characters[iChar].skill.Commerce = 1;
	characters[iChar].skill.Sneak = 1;

	characters[iChar].skill.Temp.Leadership = 1;
	characters[iChar].skill.Temp.Fencing = 1;
	characters[iChar].skill.Temp.Gun = 1;
	characters[iChar].skill.Temp.Sailing = 1;
	characters[iChar].skill.Temp.Accuracy = 1;
	characters[iChar].skill.Temp.Cannons = 1;
	characters[iChar].skill.Temp.Grappling = 1;
	characters[iChar].skill.Temp.Repair = 1;
	characters[iChar].skill.Temp.Defence = 1;
	characters[iChar].skill.Temp.Commerce = 1;
	characters[iChar].skill.Temp.Sneak = 1;

	characters[iChar].type = CharacterType; 
	characters[iChar].fantom = 1;

	if(isLock == 1)
	{
		characters[iChar].characterlock = 1;
	}

	if(iSex == MAN)
	{
		characters[iChar].sex = "man";
		characters[iChar].model.animation = "man";
		characters[iChar].model.height = 1.80
	}
	else
	{
		characters[iChar].sex = "woman";
		characters[iChar].model.animation = "towngirl";
		characters[iChar].model.height = 1.70
	}

	characters[iChar].nation = iNation;

	SetRandomNameToCharacter(&characters[iChar]);

	characters[iChar].id = characters[iChar].name + "_" + characters[iChar].lastname + "_" + rand(10000000);

	if(CharacterType == CITIZEN)
	{
		characters[iChar].type = TRADER;
		characters[iChar].rank = 1;
		characters[iChar].Skill.freeskill = 0;
		characters[iChar].perks.freepoints = 0;
		LAi_NPC_Equip(&characters[iChar], sti(characters[iChar].rank), false, false);
	}
	else
	{
		characters[iChar].rank = rand(sti(pchar.rank)) + rand(5) + 1;
		if (CharacterType == BOSS)
		{
			characters[iChar].type = WARRIOR;
			characters[iChar].rank = sti(pchar.rank) + 15 + rand(15);
			LAi_NPC_Equip(&characters[iChar], sti(characters[iChar].rank), true, true);
		}
		if (CharacterType == BOUNTY_HUNTER)
		{
			characters[iChar].type = WARRIOR;
			characters[iChar].rank = sti(pchar.rank) + 5 + rand(5);
			LAi_NPC_Equip(&characters[iChar], sti(characters[iChar].rank), true, false);
		}
		if (CharacterType == FORT_COMMANDER)
		{
			characters[iChar].type = WARRIOR;
			characters[iChar].rank = 30 + rand(20);
			LAi_NPC_Equip(&characters[iChar], sti(characters[iChar].rank), true, false);
		}
		if (CharacterType == WARRIOR)
		{
			characters[iChar].type = WARRIOR;
			LAi_NPC_Equip(&characters[iChar], sti(characters[iChar].rank), true, false);
		}
		if (CharacterType == OFFICER)
		{
			characters[iChar].type = WARRIOR;
			//LAi_NPC_Equip(&characters[iChar], sti(characters[iChar].rank), true, false);
			if(sti(characters[iChar].rank) > 15)
			{
				characters[iChar].rank = 15;
			}
		}
		if (CharacterType == SOLDIER)
		{
			characters[iChar].type = WARRIOR;
			characters[iChar].rank = 10 + rand(10) + 1;
			LAi_NPC_Equip(&characters[iChar], sti(characters[iChar].rank), true, false);
		}
		if(CharacterType == SHAMAN)
		{
			characters[iChar].type = WARRIOR;
			float fRankRange = stf(NationsState[iNation].quantity);
			characters[iChar].rank = makeint(frand(fRankRange) * 30);
			LAi_NPC_Equip(&characters[iChar], sti(characters[iChar].rank), true, false);
		}
		
		characters[iChar].Skill.freeskill = sti(characters[iChar].rank) + 1;
		characters[iChar].perks.freepoints = sti(characters[iChar].rank)/2 + 1;
	}
	
	characters[iChar].experience = CalculateExperienceFromRank(sti(characters[iChar].rank)) + rand(sti(characters[iChar].rank))*900;
	
	CreateModel(iChar, sModel, iSex);

	if (IsShip == WITH_SHIP)
	{
		if(CharacterType == FORT_COMMANDER)
		{
			characters[iChar].ship.type = GenerateShip(SHIP_FORT, isLock);
			characters[iChar].ship.Crew.Experience = sti(80 + rand(20));
		}
		else
		{
			characters[iChar].ship.type = SearchForMaxShip(&characters[iChar], isLock, CharacterType);
			if(iNation == PIRATE || iNation == SMUGGLER)
			{
				int iRShip = sti(characters[iChar].ship.type);
				iRShip = sti(RealShips[iRShip].basetype);
				if(iRShip > SHIP_PINNACE)
				{
					iRShip = rand(2) + 10;
					//   
				}
			}
			characters[iChar].ship.Crew.Experience = SetCrewExpereinceForCharacter(&characters[iChar]);
			int iRandUpgradeHull = rand(10);
			if(iRandUpgradeHull == 1)
			{
				iRandUpgradeHull = rand(2)+1;
				characters[iChar].ship.upgrades.hull = iRandUpgradeHull;
			}
			else
			{
				characters[iChar].ship.upgrades.hull = 1;
			}
			int iRandUpgradeSails = rand(10);
			if(iRandUpgradeSails == 1)
			{
				iRandUpgradeSails = rand(1)+1;
				characters[iChar].ship.upgrades.sails = iRandUpgradeSails;
			}
			else
			{
				characters[iChar].ship.upgrades.sails = 1;
			}
			int iRandUpgradeCannonsMaterial = rand(10);
			if(iRandUpgradeCannonsMaterial == 1)
			{
				iRandUpgradeCannonsMaterial = rand(2)+1;
				characters[iChar].ship.upgrades.cannons = iRandUpgradeCannonsMaterial;
			}
			else
			{
				characters[iChar].ship.upgrades.cannons = 1;
			}
		}
		
		ShipCheckUpgrade(&characters[iChar]);
		SetBaseShipData(&characters[iChar]);
		
		if(CharacterType == TRADER)
		{
			Fantom_SetGoods(&characters[iChar], "trade");
		}
		else
		{
			Fantom_SetGoods(&characters[iChar], "war");
		}
		SetRandomNameToShip(&characters[iChar]);
	}
	else
	{
		characters[iChar].ship.type = SHIP_NOTUSED;
		DeleteAttribute(&characters[iChar], "ship.upgrades");
	}

	DeleteAttribute(&characters[iChar], "perks.list");

	if(sModel != "pofficer")
	{
		RangerNextLevel(&characters[iChar]);
	}
	//trace ("iChar is " + iChar + " id is " + characters[iChar].id);

	//LAi_RemoveLoginTime(&characters[iChar]);
	if (CharacterType == BOSS)
	{
		characters[iChar].perks.list.Energaiser = true;
	}

	GenerateBootyItems(&characters[iChar]); 
	if(sti(characters[iChar].money) == 0)
	{
		characters[iChar].money = sti(characters[iChar].rank) * 100;
	}
	return iChar;
}

int CheckForQuestFree(aref chr)
{
	if(CheckAttribute(chr, "quest.work"))
	{
		if(sti(chr.quest.work) == 1)
		{
			return -1;
		}
	}

	if(CheckAttribute(chr, "currentquest"))
	{
		if(sti(chr.currentquest) != -1)
		{
			return -1;
		}
	}

	return 1;
}

void NPCGiveQuest(aref chr)
{
	int iday = environment.date.day;

	chr.quest.day = iday;	

	chr.quest.work = 1;

	DeleteAttribute(chr, "CurrentQuest,Type");
}

void EraseQuestFreeState(aref chr)
{
	DeleteAttribute(chr, "quest.day");
	DeleteAttribute(chr, "quest.work");
	DeleteAttribute(chr, "CurrentQuest");
}

int CalculateDistance(int iColonyNumber)
{
	int playership_x, playership_z;

	int iX = sti(worldMap.playerShipX)/1.66;
	int iZ = sti(worldMap.playerShipZ)/1.66;
	
	iX = 1024 + iX - 10;
	iZ = 1024 - iZ - 10;	

	playership_x = iX;
	playership_z = iZ;

	string sColony = colonies[iColonyNumber].id;

	iX = colonies[iColonyNumber].map.x;
	iZ = colonies[iColonyNumber].map.y;


	int ipX = playership_x - iX;
	int ipZ = playership_z - iZ;

	if(ipX < 0)
	{
		ipX = -ipX;
	}

	if(ipZ < 0)
	{
		ipZ = -ipZ;
	}

	iX = 0;
	iZ = 0;

	int iDist = (ipX*ipX + ipZ*ipZ);
	
	iDist = sti(sqrt(iDist)+0.5);
	
	iDist = iDist/100;

	int iDistance = iDist;

	float fDist = 1.0  + (0.1 * makefloat(iGameArcade));

	iDistance = makefloat(iDistance) * fDist;
	
	iDistance = iDistance * 2.8;

	if(iDistance < 1)
	{
		iDistance = 1;
	}
	
	return iDistance;
}

string SearchForBestSell(int iGoodIndex)
{
	int iStoreIdx;
	string sColony, sGood;
	int tradeType;
	int iColony;
	object sColonies[MAX_COLONIES];
	int m = 0;
	for(int i=0; i < MAX_COLONIES; i++)
	{
		if(colonies[i].nation != "none")
		{
			sGood = goods[iGoodIndex].name;
			sColony = colonies[i].id;
			iStoreIdx = FindStore(sColony);
			tradeType = sti(Stores[iStoreIdx].Goods.(sGood).tradetype);
			if(tradeType == TRADE_TYPE_IMPORT)
			{
				sColonies[m].colony = sColony;
				iColony = FindColony(sColony);
				sColonies[m].distance = CalculateDistance(iColony);
				m++;
			}
		}
	}

	if(m == 0)
	{
		return "not be able find best sell";
	}

	string sFinal;
	int iDistance = 1000000;
	for(int k = 0; k < m; k++)
	{
		if(iDistance > sti(sColonies[k].distance))
		{
			iDistance = sColonies[k].distance;
			sFinal = sColonies[k].colony;
		}
	}
	sFinal = "Colony"+sFinal;
	return sFinal;
}

int SearchForTrade(string sBeginColony, string sEndColony, aref chr, int iType)
{	
	//iType = 0 -   
	//iType = 1 - -   
	int iBeginStoreIdx = FindStore(sBeginColony);
	int iEndStoreIdx = FindStore(sEndColony);
	
	if(iBeginStoreIdx == -1 || iEndStoreIdx == -1)
	{
		return -1;
	}

	int iEndColony = FindColony(sEndColony);
	
	object TradeTypes[GOODS_QUANTITY];
	
	int step = 0;
	
	int iBuyPrice, iSellPrice;

	int iHomeTradeType, iTargetTradeType;
	string sGood;

	//bool isContraband = false;

	for(int i = GOOD_WHEAT; i < GOOD_SLAVES; i++)
	{
		//isContraband = false;
		sGood = Goods[i].name;
		
		iHomeTradeType = sti(Stores[iBeginStoreIdx].goods.(sGood).TradeType);
 		iTargetTradeType = sti(Stores[iEndStoreIdx].goods.(sGood).TradeType);

		if(iHomeTradeType != TRADE_TYPE_CONTRABAND && iTargetTradeType != TRADE_TYPE_CONTRABAND)
		{
			if(iType == 0)
			{
				iBuyPrice = GetStoreGoodsPrice(&Stores[iBeginStoreIdx],i,PRICE_TYPE_SELL,chr, 1);
			}
			else
			{
				iBuyPrice = GetStoreGoodsPrice(&Stores[iBeginStoreIdx],i,PRICE_TYPE_BUY,chr, 1);
			}
			iSellPrice = GetStoreGoodsPrice(&Stores[iEndStoreIdx],i,PRICE_TYPE_SELL,chr, 1);
			/*if(sti(Colonies[iEndColony].Trade.Contraband.id1) == i ||
				sti(Colonies[iEndColony].Trade.Contraband.id2) == i ||
				sti(Colonies[iEndColony].Trade.Contraband.id3) == i)
			{
				isContraband = true;
			}*/
			//if (iBuyPrice <= iSellPrice && isContraband == false)
			if (iBuyPrice <= iSellPrice)
			{
				TradeTypes[step].goodindex = i;
				step++;
			}
		}
	}
	
	if(step == 0)
	{
		return -1;
	}

	int iTrade = rand(step - 1);
	
	
	iTrade = TradeTypes[iTrade].goodindex;
	
	if (iTrade <= 0)
	{
		return -1;
	}
	
	return iTrade;
}

bool CheckForNight()
{
	int iHour = sti(environment.time);

	//Cerez: Adjusted starting from 22 to when the night falls
	if(iHour >= 20 || iHour < 6)
	{
		return true;
	}

	return false;
	
	/*if(Whr_IsDay() == 0)
	{
		return true;
	}
	return false;*/
}

int CalculateRansomPrice(aref chr)
{
	int iSumm = sti(chr.rank) * 100;
	int iFame = sti(chr.fame);
	if(iFame > 45)
	{
		iFame = iFame - 45;
	}
	else
	{
		iFame = 1;
	}
	
	if(checkAttribute(chr, "isvip"))
	{
		iSumm = iSumm * 5;
	}

	if(checkAttribute(chr, "ishovernor"))
	{
		iSumm = iSumm * 10;
	}

	iSumm = iSumm + iFame * 10;
	return iSumm;
}

bool CheckPerkAvailable(string perkName, aref xi_refCharacter)
{
	if(CheckAttribute(ChrPerksList, "list." + perkname + ".exclude.perk"))
	{
		string sExcludePerk = ChrPerksList.list.(perkname).exclude.perk;
		if(CheckAttribute(xi_refCharacter, "perks.list." + sExcludePerk))
		{
			return false;
		}
	}
	if(CheckAttribute(ChrPerksList, "list." + perkname + ".condition.perk"))
	{
		string sConditionPerk = ChrPerksList.list.(perkname).condition.perk;
		if(!CheckAttribute(xi_refCharacter, "perks.list." + sConditionPerk))
		{
			return false;
		}
	}
	if(CheckAttribute(ChrPerksList, "list." + perkname + ".condition.rank"))
	{
		if(sti(xi_refCharacter.rank) < sti(ChrPerksList.list.(perkname).condition.rank))
		{
			return false;
		}
	}
	if(CheckAttribute(ChrPerksList, "list." + perkname + ".condition.fame"))
	{
		if(sti(xi_refCharacter.fame) < sti(ChrPerksList.list.(perkname).condition.fame))
		{
			return false;
		}
	}
	return true;
}

bool CheckForPCPerk(string perkName)
{
	if(CheckAttribute(ChrPerksList, "list." + perkname + ".npconly"))
	{
		return false;
	}
	return true;
}

int GetRandomNationForMapEncounter(string sIslandID, bool bMerchant)
{
	int iNation = -1;
	if(sIslandID != "")
	{
		int iIsland = FindIsland(sIslandID);
		for(int i = 0; i < MAX_COLONIES; i++)
		{
			if(colonies[i].island == sIslandID)
			{
				if (colonies[i].nation != "none")
				{
					iNation = sti(colonies[i].nation);
				}
			}
		}
	}

	if(iNation != -1)
	{
		NationsState[iNation].quantity  = stf(NationsState[iNation].quantity) + 0.2;
	}

	float fEngland = stf(NationsState[ENGLAND].quantity);
	float fFrance = stf(NationsState[FRANCE].quantity);
	float fSpain = stf(NationsState[SPAIN].quantity);
	float fHolland = stf(NationsState[HOLLAND].quantity);
	float fPirate = stf(NationsState[PIRATE].quantity);

	if(iNation != -1)
	{
		NationsState[iNation].quantity  = stf(NationsState[iNation].quantity) - 0.2;
	}

	float fProbablyNation;
	if(bMerchant)
	{
		fProbablyNation = fEngland + fFrance + fSpain + fHolland;
	}
	else
	{
		fProbablyNation = fEngland + fFrance + fSpain + fHolland + fPirate;
	}

	fProbablyNation = frand(fProbablyNation);

	fFrance = fFrance + fEngland;
	fSpain = fFrance + fSpain;
	fHolland = fSpain + fHolland;
	fPirate = fHolland + fPirate;

	if(bMerchant == 0)
	{
		if(fProbablyNation >= fFrance && fProbablyNation < fSpain)
		{
			return FRANCE;
		}

		if(fProbablyNation >= fSpain && fProbablyNation < fHolland)
		{
			return SPAIN;
		}

		if(fProbablyNation >= fHolland && fProbablyNation < fPirate)
		{
			return HOLLAND;
		}

		if(fEngland <= fProbablyNation)
		{
			return ENGLAND;
		}
	}
	else
	{

		if(fProbablyNation >= fFrance && fProbablyNation < fSpain)
		{
			return FRANCE;
		}

		if(fProbablyNation >= fSpain && fProbablyNation < fHolland)
		{
			return SPAIN;
		}

		if(fProbablyNation >= fHolland && fProbablyNation < fPirate)
		{
			return HOLLAND;
		}

		if(fEngland <= fProbablyNation)
		{
			return ENGLAND;
		}
	}

	return PIRATE;
}

void SetNationState()
{
	NationsState[ENGLAND].quantity = 1.0;
	NationsState[FRANCE].quantity = 1.0;
	NationsState[SPAIN].quantity = 1.0;
	NationsState[HOLLAND].quantity = 1.0;
	NationsState[PIRATE].quantity = 1.0;
	NationsState[SMUGGLER].quantity = 1.0;

	NationsState[ENGLAND].isCanCaptureColonies = 1;
	NationsState[FRANCE].isCanCaptureColonies = 1;
	NationsState[SPAIN].isCanCaptureColonies = 1;
	NationsState[HOLLAND].isCanCaptureColonies = 1;
	NationsState[PIRATE].isCanCaptureColonies = 0;
	NationsState[SMUGGLER].isCanCaptureColonies = 0;
}

void FillBanksForNations()
{
	NationsState[FRANCE].bank = 0;
	NationsState[FRANCE].parcent = 0;

	NationsState[SPAIN].bank = 0;
	NationsState[SPAIN].parcent = 0;

	NationsState[ENGLAND].bank = 0;
	NationsState[ENGLAND].parcent = 0;

	NationsState[HOLLAND].bank = 0;
	NationsState[HOLLAND].parcent = 0;
}

void EmptyAllQuestData(int iQuest)
{
	aref quests, questresult;
	makearef(quests, pchar.quest);
	int iQuestsNumber = GetAttributesNum(quests);

	string sQuest;

	for(int i = 0; i < iQuestsNumber; i++)
	{
		questresult = GetAttributeN(quests, i);
		sQuest = GetAttributeName(questresult);
		if(CheckAttribute(pchar, "quest." +sQuest+".quest"))
		{
			if(iQuest == sti(pchar.quest.(sQuest).quest))
			{
				pchar.quest.(sQuest).over = "yes";
			}
		}
	}
	FoundAndDeleteAllQuestForQuestNumber(iQuest);
}

int CheckForDeclineLoadToColony(string sColony)
{
	
	int iResult = 0;
	int iColony = FindColony(sColony);
	if (CheckAttribute(pchar, "ship.crew.disease"))
	{
		if (pchar.ship.crew.disease == "1")
		{
			if (Colonies[iColony].disease != "1" && sti(Colonies[iColony].nation) != PIRATE)
			{
				iResult = 1;
			}
		}
	}
	if(CheckAttribute(&colonies[iColony], "disease.time"))
	{
		if(sti(colonies[iColony].disease.time) > 0)
		{
			iResult = 1;
		}
	}

	return iResult;
}

string CheckingTranslate(int idLngFile, string idString)
{
	string retString = LanguageConvertString ( idLngFile, idString );
	if(retString=="")
	{
		trace("Warning! No text for lable <" + idString + "> into language file <LocLables.txt>");
	}
	return retString;
}

float GetQuestPriceFromDifficulty()
{
	float fResult;

	fResult = 1.0 + (0.1 * (iGameArcade - 1));
	
	fResult = fResult + stf(pchar.rank) * 0.5;

	return fResult;
}

void LaunchMoneyGraphCollect()
{
	string sYear = "year" + worldMap.date.year;
	string sMonth = "month" + worldMap.date.month;

	pchar.money.graph.(sYear).(sMonth) = pchar.money;
}

string FindNearestFreeLocator(string group)
{
	float locx;
	float locy;
	float locz;
	string homelocator;
	
	GetCharacterPos(pchar, &locx, &locy, &locz);
	homelocator = LAi_FindNearestFreeLocator(group, locx, locy, locz);
	
	return homelocator;
}

string SetModelFlag(aref chr)
{
	string sResult = "";

	if(chr.chr_ai.type == LAI_TYPE_ACTOR)
	{
		return "";
	}

	if(CheckAttribute(&InterfaceStates,"EnabledQuestsMarks") )
	{
		if(sti(InterfaceStates.EnabledQuestsMarks) == 0)
		{
			return "";
		}
	}

	if(CheckAttribute(chr, "quest.questflag"))
	{
		switch(sti(chr.quest.questflag))
		{
			case 1:
				sResult = "exclamationmarkY";
			break;
			
			case 2:
				sResult = "questionmarkY";
			break;

			case 3:
				sResult = "questionmarkW";
			break; 
		}
	}

	chr.quest.questflag.technique = GetTechNameForSign();

	return sResult;
}

string GetTechNameForSign()
{
	return "RandItem";
}

void CheckQuestForCharacter(aref chr)
{
	if(CheckAttribute(chr, "tutorial"))
	{
		chr.quest.questflag.model = "questionmarkI";
		chr.quest.questflag.technique = GetTechNameForSign();
		return;
	}
	if(CheckAttribute(chr, "todeck"))
	{
		chr.quest.questflag.model = "questionmarkB";
		chr.quest.questflag.technique = GetTechNameForSign();
		return;
	}

	int iCheck = CheckForQuestFree(chr);
	if(iCheck != 1)
	{
		if(CheckAttribute(chr, "CurrentQuest"))
		{
			int iQuest = sti(chr.CurrentQuest);
			if(!CheckAttribute(chr, "CurrentQuest.type"))
			{
				trace("character "+ chr.id + " have no quest type field");
			}
			int iQuestType = sti(chr.CurrentQuest.type);
			string sType = "-1";
			if(CheckAttribute(&Quests[iQuest], "l.subtype"))
			{
				sType = Quests[iQuest].l.subtype;
			}
			switch (iQuestType)
			{
				case HUNT_FOR_SLAVES_QUEST:
					chr.quest.questflag = CheckSlaveQuest(chr);
				break;

				case DELIVERY_PASSENGER_QUEST:
					chr.quest.questflag = CheckForSuccesDeliveryPassenger(chr);
				break;

				case DELIVERY_TRADE_QUEST:
					chr.quest.questflag = CheckForDeliverySuccess(chr, sType);
				break;

				case SINK_SHIP_QUEST:
					chr.quest.questflag = CheckForSinkShipSuccess(chr);
				break;

				case ESCORT_SHIP_QUEST:
					chr.quest.questflag = CheckForEscortShipSuccess(chr);
				break;

				case DELIVERY_ITEM_QUEST:
					chr.quest.questflag = CheckForDeliveryItemSuccess(chr);
				break;

				case CAPTURE_FORT_QUEST:
					chr.quest.questflag = CheckForCaptureFortSuccess(chr);
				break;
			}
		}
	}

	if(!CheckAttribute(chr, "CurrentQuest"))
	{
		chr.quest.questflag = -1;
	}

	chr.quest.questflag.model = SetModelFlag(chr);

	if(CheckAttribute(chr, "quest.type"))
	{
		if(chr.quest.type == "hovernor")
		{
			if(CheckForDisease(chr) == true)
			{
				chr.greeting = GetShortNationNameByType(sti(chr.nation)) + "_gov_epidemic";
			}
			else
			{
				if(sti(chr.quest.questflag) == -1)
				{
					chr.greeting = GetShortNationNameByType(sti(chr.nation)) + "_gov_common";
					
				}
				else
				{
					if(sti(chr.quest.questflag) == 1)
					{
						chr.greeting = GetShortNationNameByType(sti(chr.nation)) + "_gov_quest";
					}
					else
					{
						chr.greeting = GetShortNationNameByType(sti(chr.nation)) + "_gov_complete";
					}
					
				}
			}
		}
		if(chr.quest.type == "trader")
		{
			string sLast = chr.greeting;
			int iLast = strlen(&sLast) - 1;
			sLast = GetSymbol(&sLast, iLast);
			if(sti(chr.quest.questflag) == -1)
			{
				chr.greeting = "tra_common_" + sLast;
				
			}
			else
			{
				if(sti(chr.quest.questflag) == 1)
				{
					chr.greeting = "tra_quest_" + sLast;
				}
				else
				{
					chr.greeting = "tra_complete_" + sLast;
				}
			}
		}
	}
}

void GenerateHovernorQuests(aref chr)
{
	int iCheck = CheckForQuestFree(chr);

	if(iCheck == 1)
	{
		GenerateCommonHovernorQuests(chr);
	}

	/*
	if(iCheck == 1)
	{
		int iStoryRandomQuest = 1;//rand(2);
		if(iStoryRandomQuest < 3 && LanguageGetLanguage() == "russian")
		{
			string sLink = SelectStoryFranceQuest(chr);
			if(sLink == "")
			{
				GenerateCommonHovernorQuests(chr);
			}
			else
			{
				GenerateStoryHovernorQuests(chr);
				chr.dialog.Filename = "StoryFranceHovernor_dialog.c";
				chr.dialog.CurrentNode = sLink;
			}
		}
		else
		{
			GenerateCommonHovernorQuests(chr);
		}
	}
	*/
}

void GenerateCommonHovernorQuests(aref chr)
{
	chr.dialog.Filename = "Hovernor_dialog.c";
	chr.dialog.CurrentNode = "Second Time";
	int iquesttype = SelectCareerQuest(chr);

	//iquesttype = DELIVERY_TRADE_QUEST; 

	switch(iquesttype)
	{
		case DELIVERY_TRADE_QUEST:
			chr.quest.questflag = GenerateDeliveryTradeQuest(chr, rand(1), "career", 1, 1);
		break;

		case DELIVERY_PASSENGER_QUEST:
			chr.quest.questflag = GeneratePassengerQuest(chr, rand(1), "Career", 1, rand(1), 1, 1);
		break;

		case SINK_SHIP_QUEST:
			chr.quest.questflag = GenerateSinkShipQuest(chr, "career", 1, 1, 1, rand(1), rand(2)+1);
		break;

		case ESCORT_SHIP_QUEST:
			chr.quest.questflag = GenerateEscortQuest(chr, rand(1), "career", 1, rand(1), 1, 1);
		break;

		case DELIVERY_ITEM_QUEST:
			chr.quest.questflag = GenerateDeliveryItemQuest(chr, rand(1), "career", 1, 1, rand(3));
		break;

		case CAPTURE_FORT_QUEST:
			chr.quest.questflag = GenerateCaptureFortQuest(chr);
		break;

		case KILL_CHARACTER_QUEST:
			chr.quest.questflag = GeneratePassengerQuest(chr, rand(1), "Career", 1, rand(1), 1, 1);
		break;

		case TALK_WITH_CHARACTER_QUEST:
			chr.quest.questflag = GeneratePassengerQuest(chr, rand(1), "Career", 1, rand(1), 1, 1);
		break;
		
		case LOOK_AT_SOMETHING_QUEST:
			chr.quest.questflag = GeneratePassengerQuest(chr, rand(1), "Career", 1, rand(1), 1, 1);
		break;

	}
	if(sti(chr.quest.questflag) == -1)
	{
		string sQuest = "RechargeHovernorQuests_" + chr.id;
		pchar.quest.(sQuest).win_condition.l1 = "Timer";
		pchar.quest.(sQuest).win_condition.l1.date.day = GetAddingDataDay(0, 0, 1);
		pchar.quest.(sQuest).win_condition.l1.date.month = GetAddingDataMonth(0, 0, 1);
		pchar.quest.(sQuest).win_condition.l1.date.year = GetAddingDataYear(0, 0, 1);
		pchar.quest.(sQuest).win_condition.l1.date.hour = rand(23);
		pchar.quest.(sQuest).win_condition = "RechargeHovernorQuests";
		pchar.quest.(sQuest).function = "RechargeHovernorQuests";
		pchar.quest.(sQuest).character = chr.id;
	}
	else
	{
		CheckQuestForCharacter(chr);
	}
}

void RechargeHovernorQuests(string sQuest)
{
	ref chr = characterFromID(pchar.quest.(sQuest).character);
	if(sti(chr.quest.questflag) == -1)
	{
		DeleteAttribute(chr, "CurrentQuest");
	}
}

void GenerateTraderQuests(aref chr)
{
	if(!CheckAttribute(chr, "day") || chr.day != environment.date.day)
	{
		chr.day = environment.date.day;
		if(rand(2) == 1)
		{
			int iCheck = CheckForQuestFree(chr);
			if(iCheck == 1)
			{
				int iquesttype = 0;
				switch(iquesttype)
				{
					case DELIVERY_TRADE_QUEST:
						chr.quest.questflag = GenerateDeliveryTradeQuest(chr, rand(1), "", 0, 0);
					break;
				}
			}
		}
	}
}

string SelectHovernorQuestText(aref chr, ref sAgreeLink, ref sDeclineLink)
{
	string sResult = "-1";
	if(CheckAttribute(chr, "CurrentQuest"))
	{
		int iQuestType = sti(chr.Currentquest.type);
		switch(iQuestType)
		{
			case DELIVERY_PASSENGER_QUEST:
				sResult = SelectDeliveryPassengerDialog(chr);
				sAgreeLink = "delivery_passenger_accept";
				sDeclineLink = "delivery_passenger_decline";
			break;

			case DELIVERY_TRADE_QUEST:
				sResult = SelectDeliveryTradeDialog(chr);
				sAgreeLink = "delivery_trade_accept";
				sDeclineLink = "delivery_trade_decline";
			break;

			case SINK_SHIP_QUEST:
				sResult = SelectSinkShipDialog(chr);
				sAgreeLink = "sink_ship_accept";
				sDeclineLink = "sink_ship_decline";
			break;

			case ESCORT_SHIP_QUEST:
				sResult = SelectEscortShipDialog(chr);
				sAgreeLink = "escort_ship_accept";
				sDeclineLink = "escort_ship_decline";
			break;

			case DELIVERY_ITEM_QUEST:
				sResult = SelectDeliveryItemDialog(chr);
				sAgreeLink = "delivery_item_accept";
				sDeclineLink = "delivery_item_decline";
			break;

			case CAPTURE_FORT_QUEST:
				sResult = SelectCaptureFortDialog(chr);
				sAgreeLink = "capture_fort_accept";
				sDeclineLink = "capture_fort_decline";
			break;
		}
	}
	return sResult;
}

string SelectHovernorQuestReminderText(aref chr)
{
	string sResult = "-1";
	if(CheckAttribute(chr, "CurrentQuest"))
	{
		int iQuestType = sti(chr.Currentquest.type);
		switch(iQuestType)
		{
			case DELIVERY_PASSENGER_QUEST:
				sResult = SelectDeliveryPassengerReminderDialog(chr);
			break;

			case DELIVERY_TRADE_QUEST:
				sResult = SelectDeliveryTradeReminderDialog(chr);
			break;

			case SINK_SHIP_QUEST:
				sResult = SelectSinkShipReminderDialog(chr);
			break;

			case ESCORT_SHIP_QUEST:
				sResult = SelectEscortShipReminderDialog(chr);
			break;

			case DELIVERY_ITEM_QUEST:
				sResult = SelectDeliveryItemReminderDialog(chr);
			break;

			case CAPTURE_FORT_QUEST:
				sResult = SelectCaptureFortReminderDialog(chr);
			break;

		}
	}
	return sResult;
}

void CharacterDoneQuest(aref chr)
{
	int iQuest = sti(chr.CurrentQuest);
	int iQuestType = sti(Quests[iQuest].l.type);
	switch(iQuestType)
	{
		case DELIVERY_TRADE_QUEST:
			CompleteDeliveryTradeQuest(chr);
		break;

		case DELIVERY_PASSENGER_QUEST:
			CompletePassengerQuest(chr);
		break;

		case SINK_SHIP_QUEST:
			CompleteShipSinkQuest(chr);
		break;

		case ESCORT_SHIP_QUEST:
			CompleteEscortTradeShipQuest(chr);
		break;

		case DELIVERY_ITEM_QUEST:
			CompleteDeliveryItemQuest(chr);
		break;
		case CAPTURE_FORT_QUEST:
			CompleteCaptureFortQuest(chr);
		break;
	}
}

string GetCrewEquipmentName(aref chr)
{
	string sBlade = "RustyBlades";
	
	int iCrewExp = sti(chr.ship.crew.experience);
	
	if(iCrewExp < 100)
	{
		sBlade = "GloriousBlades";
	}

	if(iCrewExp < 75)
	{
		sBlade = "GoodBlades";
	}

	if(iCrewExp < 50)
	{
		sBlade = "NormalBlades";
	}

	if(iCrewExp < 25)
	{
		sBlade = "RustyBlades";
	}
	
	sBlade = XI_ConvertString(sBlade);
	return sBlade;
}

int GetRandomNationForMapEncounterBattle(string sIslandID, ref Encounter)
{
	int iNation = -1;
	if(sIslandID != "")
	{
		int iIsland = FindIsland(sIslandID);
		for(int i = 0; i < MAX_COLONIES; i++)
		{
			if(colonies[i].island == sIslandID)
			{
				if (colonies[i].nation != "none")
				{
					iNation = sti(colonies[i].nation);
				}
			}
		}
	}

	if(iNation != -1)
	{
		NationsState[iNation].quantity  = stf(NationsState[iNation].quantity) + 0.2;
	}

	float fEngland = stf(NationsState[ENGLAND].quantity);
	float fFrance = stf(NationsState[FRANCE].quantity);
	float fSpain = stf(NationsState[SPAIN].quantity);
	float fHolland = stf(NationsState[HOLLAND].quantity);
	float fPirate = stf(NationsState[PIRATE].quantity);

	if(iNation != -1)
	{
		NationsState[iNation].quantity  = stf(NationsState[iNation].quantity) - 0.2;
	}

	float fProbablyNation;
	
	fProbablyNation = fEngland + fFrance + fSpain + fHolland + fPirate;

	fProbablyNation = frand(fProbablyNation);

	fFrance = fFrance + fEngland;
	fSpain = fFrance + fSpain;
	fHolland = fSpain + fHolland;
	fPirate = fHolland + fPirate;

	int iNation2 = -1;
	if(CheckAttribute(Encounter, "nation"))
	{
		if (sti(Encounter.nation) != -1)
		{
			iNation2 = sti(Encounter.nation);

			if(fProbablyNation >= fFrance && fProbablyNation < fSpain && GetNationRelation(FRANCE, iNation2) == RELATION_ENEMY)
			{
				return FRANCE;
			}

			if(fProbablyNation >= fSpain && fProbablyNation < fHolland && GetNationRelation(SPAIN, iNation2) == RELATION_ENEMY)
			{
				return SPAIN;
			}

			if(fProbablyNation >= fHolland && fProbablyNation < fPirate && GetNationRelation(HOLLAND, iNation2) == RELATION_ENEMY)
			{
				return HOLLAND;
			}

			if(fEngland <= fProbablyNation && GetNationRelation(ENGLAND, iNation2) == RELATION_ENEMY)
			{
				return ENGLAND;
			}
		}
	}

	if(fProbablyNation >= fFrance && fProbablyNation < fSpain)
	{
		return FRANCE;
	}

	if(fProbablyNation >= fSpain && fProbablyNation < fHolland)
	{
		return SPAIN;
	}

	if(fProbablyNation >= fHolland && fProbablyNation < fPirate)
	{
		return HOLLAND;
	}

	if(fEngland <= fProbablyNation)
	{
		return ENGLAND;
	}


	return PIRATE;
}

void MakeDonate(ref chr)
{
	int iNation = sti(chr.nation);
	int iDonate = sti(chr.donate);

	string sNation = GetNationNameByType(iNation);

	int iReputation = 0.0;
	if(CheckAttribute(pchar, "reputation." + sNation))
	{
		iReputation = sti(pchar.reputation.(sNation));
	}

	AddMoneyToCharacter(pchar, -iDonate);

	iDonate = iDonate / 1000;

	ChangeCharacterReputation(pchar, iDonate, iNation);

	
}

void ChangeNationRelationFromRelationAgent(aref chr)
{
	int iNation = sti(chr.quest.relation);
	int iSumm = sti(chr.quest.relation.summ);

	AddMoneyToCharacter(pchar, -iSumm);

	string sQuest = "Change_Relation_for_Nation_" + GetNationNameByType(iNation) + "_by_relation_agent_" + rand(10000);
	int iDays = rand(2) + 1;
	pchar.quest.(sQuest).win_condition.l1 = "timer";
	pchar.quest.(sQuest).win_condition.l1.date.day = GetAddingDataDay(0, 0, iDays);
	pchar.quest.(sQuest).win_condition.l1.date.month = GetAddingDataMonth(0, 0, iDays);
	pchar.quest.(sQuest).win_condition.l1.date.year = GetAddingDataYear(0, 0, iDays);
	pchar.quest.(sQuest).win_condition.l1.date.hour = rand(23);
	pchar.quest.(sQuest).win_condition = "Change_Relation_for_Nation_by_relation_agent";
	pchar.quest.(sQuest).function = "ChangeNationRelationFromRelationAgentComplete";
	pchar.quest.(sQuest).nation = iNation;
}

void ChangeNationRelationFromRelationAgentComplete(string sQuest)
{
	int iNation = sti(pchar.quest.(sQuest).nation);
	string sNation = GetNationNameByType(iNation);

	SetRelations(iNation, RELATION_NEUTRAL);
	if(sti(pchar.reputation.(sNation)) < 40)
	{
		pchar.reputation.(sNation) = 40;
	}

}

int FindNationForCapturingColony()
{
	object smallnations[MAX_NATIONS];
	int m = 0;
	for(int i = 0; i < MAX_NATIONS; i++)
	{
		if(sti(NationsState[i].isCanCaptureColonies) == 1)
		{
			smallnations[m].nation = i;
			m = m + 1;
		}
	}
	if(m < 1)
	{
		return -1;
	}
	m = rand(m - 1);
	return sti(smallnations[m].nation);
}

void CheckStoryLineRank(string sQuest, int iRank)
{
	string sNewQuest = "Rank_Check_" + rand(10000);
	while(sQuest == sNewQuest)
	{
		sNewQuest = "Rank" + iRank + "_Check_" + rand(10000);
	}
	pchar.quest.(sNewQuest).win_condition.l1 = "timer";
	pchar.quest.(sNewQuest).win_condition.l1.date.day = GetAddingDataDay(0, 0, 2);
	pchar.quest.(sNewQuest).win_condition.l1.date.month = GetAddingDataMonth(0, 0, 2);
	pchar.quest.(sNewQuest).win_condition.l1.date.year = GetAddingDataYear(0, 0, 2);
	pchar.quest.(sNewQuest).win_condition.l1.date.hour = rand(23);
	string sFunction = "rank"+ iRank + " check";
	pchar.quest.(sNewQuest).win_condition = sFunction;
}

void CheckAiGroups()
{
	for(int kk=0; kk<128; kk++) 
	{ 
		Trace("grp = " + AIGroups[kk].id); 
	}
}

void GenerateBootyItems(aref chr)
{
	int j = 0;
	object oItemList[ITEMS_QUANTITY];
	int iItemIdx = -1;
	int iChecker = rand(100);

	float fLuck = GetSummonSkillFromName(pchar, SKILL_SNEAK);
	fLuck = fLuck * (1.0 + (0.5 * iGameArcade));

	for(int i = 0; i < ITEMS_QUANTITY; i++ ) 
	{
		if(!CheckAttribute(&Items[i], "groupID")) 
		{
			continue;
		}

		if(Items[i].groupID == SABERGUN_ITEM_TYPE)
		{
			continue;
		}

		if(!CheckAttribute(&Items[i], "rare")) 
		{
			continue;
		}

		if(CheckAttribute(&Items[i], "uniq")) 
		{
			if(sti(Items[i].uniq) == 0)
			{
				DeleteAttribute(&Items[i], "uniq.taked"));
			}
		}

		if(CheckAttribute(&Items[i], "uniq.taked")) 
		{
			if(sti(Items[i].uniq) == 1 && sti(Items[i].uniq.taked) == 1)
			{
				continue;
			}
		}

		if(CheckAttribute(&items[i], "minlevel"))
		{
			if(sti(items[i].minlevel) > sti(pchar.rank) + 3)
			{
				continue;
			}
		}

		if(Items[i].groupID == SPYGLASS_ITEM_TYPE)
		{
			if(Items[i].id == "spyglass1" && sti(Items[i].rare) != 36)
			{
				Items[i].rare = 36;
			}
			if(Items[i].id == "spyglass2" && sti(Items[i].rare) != 30)
			{
				Items[i].rare = 30;
			}
			if(Items[i].id == "spyglass3" && sti(Items[i].rare) != 24)
			{
				Items[i].rare = 24;
			}
			if(Items[i].id == "spyglass4" && sti(Items[i].rare) != 18)
			{
				Items[i].rare = 18;
			}
		}

		if((stf(Items[i].rare) + fLuck) >= iChecker) 
		{
			oItemList[j].item = i;
			j++;
		}
	}

	if(j > 0 ) 
	{
		j = rand(j - 1);
		iItemIdx = sti(oItemList[j].item);
	}

	if(iItemIdx >= 0)
	{
		if(CheckAttribute(&Items[iItemIdx], "uniq")) 
		{
			Items[iItemIdx].uniq.taked = 1;
		}
		chr.booty.item = iItemIdx;
	}
}

int FindRandomInhabittainColony()
{
	object oColonies[MAX_COLONIES];
	int m = 0;
	for(int i = 0; i < MAX_COLONIES; i++)
	{
		if(colonies[i].nation == "none" && colonies[i].id != "IslaMona")
		{
			oColonies[m].colony = i;
			m++;
		}
	}

	m = rand(m - 1);

	return (sti(oColonies[m].colony));
}

bool CheckForStoreItem(int iItem)
{
	if(sti(Items[iItem].price) == 0)
	{
		return false;
	}
	if(CheckAttribute(&Items[iItem], "type"))
	{
		if(Items[iItem].type == "quest")
		{
			return false;
		}
	}
	return true;
}

void TestLoginedCharacters()
{
	int index = -1;
	int iNation = -1;
	string sNation = "";
	string sLaiGroup = "";
	for(int i = 0; i < LAi_numloginedcharacters; i++)
	{
		index = LAi_loginedcharacters[i];
		if(index >= 0)
		{
			iNation = sti(characters[index].nation);
			sNation = GetNationNameByType(iNation);
			sLaiGroup = characters[index].chr_ai.group;
			//
		}
	}
}

int FindColonyForTargetIsland(int iIsland)
{
	for(int i = 0; i < MAX_COLONIES; i++)
	{
		if(colonies[i].island == Islands[iIsland].id)
		{
			return i;
		}
	}
	return -1;
}

bool String_IsEmpty(ref rStr)
{
	if (rStr == "") { return true; }
	for (int i=0; i<strlen(&rStr); i++)	{ if (GetSymbol(&rStr, i) != " ") { return false; }	}
	return true;
}

//: fPercentChance = 0.0f .. 100.0f
bool utils_GetProbability(float fPercentChance)	
{
	return rand(10000) > (10000.0 * (1.0 - (fPercentChance / 100.0)));
}